/* ansi9t.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

#ifndef _ansi9t_HEADER_
#define _ansi9t_HEADER_

// Handy ANSI tape format information derived from the "ansitar" program
// source, whose original author is apparently unknown
//
// The real scoop is probably in "ANSI Standard X3.27 Magnetic Tape Labels
// and File Structure for Information Interchange", but I can't afford it.
//
// There is some information in ACR/NEMA PS1 "Standard For Magnetic Tape"
// which uses the ANSI 3.27 format.

union AnsiHdr {
		char buffer[81];	// include space for trailing 0
		struct Common {
			char labelid[3];
			char labelno[1];
		} c;
		struct Vol1 {
			char labelid[3];		// "VOL"
			char labelno[1];		// "1"
			char volumeid[6];
			char accessibility[1];		// " " = all
			char reserved1[26];
			char ownerid[14]; 
			char reserved2[28];
			char labelstandardversion[1];	// 1,2,3
		} vol1;
		struct Hdr1 {
			char labelid[3];		// "HDR","EOF","EOV"
			char labelno[1];		// "1"
			char fileid[17];
			char filesetid[6];
			char filesectionnumber[4];
			char filesequencenumber[4];
			char generationnumber[4];
			char generationversionnumber[2];
			char creationdate[6];		// " yyddd"
			char expirationdate[6];		// " yyddd"
			char accessibility[1];		// " " = all
			char blockcount[6];
			char systemcode[13];
			char reserved1[7];
		} hdr1;
		struct Hdr2 {
			char labelid[3];		// "HDR","EOF","EOV"
			char labelno[1];		// "2"
			char recordformat[1];		// "F" or "D"
			char blocklength[5];
			char recordlength[5];
			char reserved1[35];
			char bufferoffsetlength[2];
			char reserved2[28];
		} hdr2;
		struct Usr {
			char labelid[3];		// "UHL","UTL","UVL"
			char labelno[1];		// [1-9] UVL
							// [1-9a-zA-Z] UHL,UTL
			char reserved1[76];
		} usr;
};

#endif /* _ansi9t_HEADER_ */
