/* gbsman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// ReferringPhysicianName = ""

		DC3Tag tag (DC3ReferringPhysicianName_GROUP,
			    DC3ReferringPhysicianName_ELEMENT);

		DC3PersonName *attribute = MakePersonNameEmpty(tag);

		list.insert(attribute);
	}
	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);

		DC3ShortString *attribute = MakeShortStringEmpty(tag);

		list.insert(attribute);
	}
	{
		// StudyID = "1"

		DC3Tag tag (DC3StudyID_GROUP,
			    DC3StudyID_ELEMENT);

		DC3ShortString *attribute =
			MakeShortStringFromString(tag,"1");

		list.insert(attribute);
	}
	{
		// SeriesNumber = "1"

		DC3Tag tag (DC3SeriesNumber_GROUP,
			    DC3SeriesNumber_ELEMENT);

		DC3IntegerString *attribute =
			MakeIntegerStringFromUnsigned(tag,1);

		list.insert(attribute);
	}
	{
		// PatientSex = ""

		DC3Tag tag (DC3PatientSex_GROUP,
			    DC3PatientSex_ELEMENT);

		DC3CodeString *attribute = MakeCodeStringEmpty(tag);

		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);

		DC3DateString *attribute = MakeDateStringEmpty(tag);

		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,DC3MRImageStorageSOPClass);

		list.insert(attribute);
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,1,1,gbs_IMAGE_NUMBER.toUS());

		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid(stamp,1);

		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid(stamp,1,1);

		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid(stamp,1,1);

		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{
		// PositionReferenceIndicator = ""

		DC3Tag tag (DC3PositionReferenceIndicator_GROUP,
			    DC3PositionReferenceIndicator_ELEMENT);

		DC3LongString *attribute =
			MakeLongStringEmpty(tag);

		list.insert(attribute);
	}
	{
		// PixelSpacing
		// ReconstructionDiameter

		double spacing  = 100.0 / (double)gbs_PIXELS_10CM.toUS();
		double diameter = (double)gbs_MATRIX.toUS() * spacing;

		{
			DC3Tag tag (DC3PixelSpacing_GROUP,
				    DC3PixelSpacing_ELEMENT);

			DC3DecimalString *attribute =
				MakeDecimalStringFromTwoDouble(tag,
					spacing,spacing);

			list.insert(attribute);
		}
		{
			DC3Tag tag (DC3ReconstructionDiameter_GROUP,
				    DC3ReconstructionDiameter_ELEMENT);

			DC3DecimalString *attribute =
				MakeDecimalStringFromDouble(tag,diameter);

			list.insert(attribute);
		}

		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		// Magnetom plane definitions are unknown:
		// assume Left Ant Superior +ve (for no really good reason)

		// DICOM plane definitions are:
		// - Left Pos Superior +ve

		ImagePlanePlane plane;

		switch (gbs_ORIENT_SLICE.toUS()) {
			case 1:		// X
					plane=Sagittal;
					break;
			case 2:		// Y
					plane=Coronal;
					break;
			case 3:		// Z
					plane=Axial;
					break;
			default:	// :(
					plane=Axial;
					break;
		}

		ImagePlaneHeadFeet orientation;

		switch (gbs_ORIENT1.toSS()) {
			case -1:	
					hfff="HF";
					orientation=HeadFirst;
					break;
			case 1:	
					hfff="FF";
					orientation=FeetFirst;
					break;
			default:
					hfff="";		// :(
					orientation=HeadFirst;
					break;
		}

		ImagePlanePosition position;

		switch (gbs_ORIENT2.toUS()) {
			case 1:		// Supine
					ap="S";
					position=Supine;
					break;
			case 2:		// Prone
					ap="P";
					position=Prone;
					break;
			case 3:		// Right Lateral Decubitus
					ap="DR";
					position=RightLateralDecubitus;
					break;
			case 4:		// Left Lateral Decubitus
					ap="DL";
					position=LeftLateralDecubitus;
					break;
			default:	ap="";			// :(
					position=Supine;
					break;
		}

		// Make a model of the image plane ...

		ImagePlane imageplane(plane,diameter,orientation,position);

		switch (gbs_VIEW_DIR.toSS()) {
			case 1:		// Cranial  - normal - do nothing
					break;
			case -1:	// Caudal - looking from above down
					// so flip left/right ...
					imageplane.MachinePlane::angle(
							AnteriorPosterior,
							180);
					break;
		}

		// no idea which direction angles are really ... :(
		// sample brain axial angle is +ve, so probably +ve ant sup

		imageplane.MachinePlane::angle(
				LeftRight,
				(double)gbs_ANGLE_ROUND_X.toSS());
		imageplane.MachinePlane::angle(
				AnteriorPosterior,
				(double)gbs_ANGLE_ROUND_Y.toSS());
		imageplane.MachinePlane::angle(
				HeadFeet,
				(double)gbs_ANGLE_ROUND_Z.toSS());

		double sliceposn;
		switch (gbs_ACTUAL_SLICE.toUS()) {
			case 1:  sliceposn=gbs_SLDIST_1.todouble();  break;
			case 2:  sliceposn=gbs_SLDIST_2.todouble();  break;
			case 3:  sliceposn=gbs_SLDIST_3.todouble();  break;
			case 4:  sliceposn=gbs_SLDIST_4.todouble();  break;
			case 5:  sliceposn=gbs_SLDIST_5.todouble();  break;
			case 6:  sliceposn=gbs_SLDIST_6.todouble();  break;
			case 7:  sliceposn=gbs_SLDIST_7.todouble();  break;
			case 8:  sliceposn=gbs_SLDIST_8.todouble();  break;
			case 9:  sliceposn=gbs_SLDIST_9.todouble();  break;
			case 10: sliceposn=gbs_SLDIST_10.todouble(); break;
			case 11: sliceposn=gbs_SLDIST_11.todouble(); break;
			case 12: sliceposn=gbs_SLDIST_12.todouble(); break;
			case 13: sliceposn=gbs_SLDIST_13.todouble(); break;
			case 14: sliceposn=gbs_SLDIST_14.todouble(); break;
			case 15: sliceposn=gbs_SLDIST_15.todouble(); break;
			case 16: sliceposn=gbs_SLDIST_16.todouble(); break;
			case 17: sliceposn=gbs_SLDIST_17.todouble(); break;
			case 18: sliceposn=gbs_SLDIST_18.todouble(); break;
			case 19: sliceposn=gbs_SLDIST_19.todouble(); break;
			case 20: sliceposn=gbs_SLDIST_20.todouble(); break;
			case 21: sliceposn=gbs_SLDIST_21.todouble(); break;
			case 22: sliceposn=gbs_SLDIST_22.todouble(); break;
			case 23: sliceposn=gbs_SLDIST_23.todouble(); break;
			case 24: sliceposn=gbs_SLDIST_24.todouble(); break;
			case 25: sliceposn=gbs_SLDIST_25.todouble(); break;
			case 26: sliceposn=gbs_SLDIST_26.todouble(); break;
			case 27: sliceposn=gbs_SLDIST_27.todouble(); break;
			case 28: sliceposn=gbs_SLDIST_28.todouble(); break;
			case 29: sliceposn=gbs_SLDIST_29.todouble(); break;
			case 30: sliceposn=gbs_SLDIST_30.todouble(); break;
			case 31: sliceposn=gbs_SLDIST_31.todouble(); break;
			case 32: sliceposn=gbs_SLDIST_32.todouble(); break;
			default: sliceposn=0; break;
		}

		imageplane.MachinePlane::shift(Vector3D(0,0,sliceposn));

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);

			DC3CodeString *attribute =
				MakeCodeStringFromConcatTwoStrings(tag,
				hfff,ap);

			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromThreeDouble(tag,
				imageplane.PatientPlane::getTLHC().getX(),
				imageplane.PatientPlane::getTLHC().getY(),
				imageplane.PatientPlane::getTLHC().getZ());

			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromSixDouble(tag,
				imageplane.PatientPlane::getRowVector().getX(),
				imageplane.PatientPlane::getRowVector().getY(),
				imageplane.PatientPlane::getRowVector().getZ(),
				imageplane.PatientPlane::getColVector().getX(),
				imageplane.PatientPlane::getColVector().getY(),
				imageplane.PatientPlane::getColVector().getZ());

			list.insert(attribute);
		}
		{
			// ImagePosition

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromThreeDouble(tag,
				imageplane.MachinePlane::getTLHC().getX(),
				imageplane.MachinePlane::getTLHC().getY(),
				imageplane.MachinePlane::getTLHC().getZ());

			list.insert(attribute);
		}
		{
			// ImageOrientation

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromSixDouble(tag,
				imageplane.MachinePlane::getRowVector().getX(),
				imageplane.MachinePlane::getRowVector().getY(),
				imageplane.MachinePlane::getRowVector().getZ(),
				imageplane.MachinePlane::getColVector().getX(),
				imageplane.MachinePlane::getColVector().getY(),
				imageplane.MachinePlane::getColVector().getZ());

			list.insert(attribute);
		}
		{
			// PatientOrientation

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);

			DC3CodeString *attribute =
				MakeCodeStringFromTwoStringValues(tag,
			(char *)(imageplane.PatientPlane::getRowOrientation()),
			(char *)(imageplane.PatientPlane::getColOrientation()));

			list.insert(attribute);
		}
	}
	{
		// ImagesInAcquisition

		unsigned nslices = (gbs_3DRESOLUTION.toUS() == 1)
					? gbs_NSLICES.toUS()
					: gbs_3DSLICES.toUS();

		DC3Tag tag (DC3ImagesInAcquisition_GROUP,
			    DC3ImagesInAcquisition_ELEMENT);

		DC3IntegerString *attribute =
			MakeIntegerStringFromUnsigned(tag,nslices);

		list.insert(attribute);
	}
	{
		// SpacingBetweenSlices

		double slicespacing = (gbs_NSLICES.toUS() == 1)
					? 0.0
					: fabs(gbs_SLDIST_1.todouble()
						- gbs_SLDIST_2.todouble());

		DC3Tag tag (DC3SpacingBetweenSlices_GROUP,
			    DC3SpacingBetweenSlices_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromDouble(tag,slicespacing);

		list.insert(attribute);
	}
