/* gbsman2.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

#include "Month.h"

	{
		// ImageDate
		// StudyDate
		// SeriesDate
		// AcquisitionDate

		unsigned month=MonthMMMtoMM(gbs_DATE_MMM.toSH());

		{
			DC3Tag tag (DC3ImageDate_GROUP,
			    DC3ImageDate_ELEMENT);

			DC3DateString *attribute =
				MakeDateStringFromThreeValues(tag,
					gbs_DATE_YY.toUS(),
					month,
					gbs_DATE_DD.toUS());

			list.insert(attribute);
		}
		{
			DC3Tag tag (DC3StudyDate_GROUP,
			    DC3StudyDate_ELEMENT);

			DC3DateString *attribute =
				MakeDateStringFromThreeValues(tag,
					gbs_DATE_YY.toUS(),
					month,
					gbs_DATE_DD.toUS());

			list.insert(attribute);
		}
		{
			DC3Tag tag (DC3SeriesDate_GROUP,
			    DC3SeriesDate_ELEMENT);

			DC3DateString *attribute =
				MakeDateStringFromThreeValues(tag,
					gbs_DATE_YY.toUS(),
					month,
					gbs_DATE_DD.toUS());

			list.insert(attribute);
		}
		{
			DC3Tag tag (DC3AcquisitionDate_GROUP,
			    DC3AcquisitionDate_ELEMENT);

			DC3DateString *attribute =
				MakeDateStringFromThreeValues(tag,
					gbs_DATE_YY.toUS(),
					month,
					gbs_DATE_DD.toUS());

			list.insert(attribute);
		}
	}
	{
		// ImageTime

		DC3Tag tag (DC3ImageTime_GROUP,
			    DC3ImageTime_ELEMENT);

		DC3TimeString *attribute =
			MakeTimeStringFromThreeValues(tag,
			gbs_TIME_HH.toUS(),
			gbs_TIME_MM.toUS(),
			gbs_TIME_SS.toUS());

		list.insert(attribute);
	}
	{
		// StudyTime

		DC3Tag tag (DC3StudyTime_GROUP,
			    DC3StudyTime_ELEMENT);

		DC3TimeString *attribute =
			MakeTimeStringFromThreeValues(tag,
			gbs_TIME_HH.toUS(),
			gbs_TIME_MM.toUS(),
			gbs_TIME_SS.toUS());

		list.insert(attribute);
	}
	{
		// SeriesTime

		DC3Tag tag (DC3SeriesTime_GROUP,
			    DC3SeriesTime_ELEMENT);

		DC3TimeString *attribute =
			MakeTimeStringFromThreeValues(tag,
			gbs_TIME_HH.toUS(),
			gbs_TIME_MM.toUS(),
			gbs_TIME_SS.toUS());

		list.insert(attribute);
	}
	{
		// AcquisitionTime

		DC3Tag tag (DC3AcquisitionTime_GROUP,
			    DC3AcquisitionTime_ELEMENT);

		DC3TimeString *attribute =
			MakeTimeStringFromThreeValues(tag,
			gbs_TIME_HH.toUS(),
			gbs_TIME_MM.toUS(),
			gbs_TIME_SS.toUS());

		list.insert(attribute);
	}
	{
		// ImagingFrequency

		DC3Tag tag (DC3ImagingFrequency_GROUP,
			    DC3ImagingFrequency_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromDouble(tag,
				(double)gbs_NMRFREQ_HZ.toUL()/1000000.0);

		list.insert(attribute);
	}
	{
		// RepetitionTime

		DC3Tag tag (DC3RepetitionTime_GROUP,
			    DC3RepetitionTime_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromDouble(tag,
				gbs_TR_SECS.todouble()*1000.0);

		list.insert(attribute);
	}
	if (gbs_MEAS_TYPE.toUS() == 200) {	// Inversion recovery
						// ?? should use text field ??
		// InversionTime

		DC3Tag tag (DC3InversionTime_GROUP,
			    DC3InversionTime_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromDouble(tag,
				gbs_TI_SECS.todouble()*1000.0);

		list.insert(attribute);
	}

	// not present value seems to be "-999" but just in case ...
	// ?? should use text field if present ??

	if (gbs_FLIP_ANGLE.toSS() > 0 && gbs_FLIP_ANGLE.toSS() <= 360) {

		// FlipAngle

		DC3Tag tag (DC3FlipAngle_GROUP,
			    DC3FlipAngle_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromSigned(tag,
				gbs_FLIP_ANGLE.toSS());

		list.insert(attribute);
	}

	// Do the constant stuff ...

	{
		// Manufacturer = "SIEMENS"

		DC3Tag tag (DC3Manufacturer_GROUP,
			    DC3Manufacturer_ELEMENT);

		DC3LongString *attribute =
			MakeLongStringFromString(tag,"SIEMENS");

		list.insert(attribute);
	}
	{
		// ManufacturerModelName = "MAGNETOM GBS"

		DC3Tag tag (DC3ManufacturerModelName_GROUP,
			    DC3ManufacturerModelName_ELEMENT);

		DC3LongString *attribute =
			MakeLongStringFromString(tag,"MAGNETOM GBS");

		list.insert(attribute);
	}
	{
		// Modality = MR

		DC3Tag tag (DC3Modality_GROUP,
			    DC3Modality_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromString(tag,"MR");

		list.insert(attribute);
	}
	{
		// PixelPaddingValue = 0

		DC3Tag tag (DC3PixelPaddingValue_GROUP,
			    DC3PixelPaddingValue_ELEMENT);
		Uint16 i = 0;
		DC3UnspecifiedShort *attribute =
			new DC3UnspecifiedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// BitsAllocated = 16

		DC3Tag tag (DC3BitsAllocated_GROUP,
			    DC3BitsAllocated_ELEMENT);
		Uint16 i = 16;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// BitsStored = 12

		// should use the IMAGE_MASK and ROI_MASK and ROI_USE values ?

		DC3Tag tag (DC3BitsStored_GROUP,
			    DC3BitsStored_ELEMENT);
		Uint16 i = 12;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// HighBit = 11

		DC3Tag tag (DC3HighBit_GROUP,
			    DC3HighBit_ELEMENT);
		Uint16 i = 11;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PixelRepresentation = 0 (unsigned)

		DC3Tag tag (DC3PixelRepresentation_GROUP,
			    DC3PixelRepresentation_ELEMENT);
		Uint16 i = 0;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// SamplesPerPixel = 1

		DC3Tag tag (DC3SamplesPerPixel_GROUP,
			    DC3SamplesPerPixel_ELEMENT);
		Uint16 i = 1;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PhotometricInterpretation = MONOCHROME2

		DC3Tag tag (DC3PhotometricInterpretation_GROUP,
			    DC3PhotometricInterpretation_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromString(tag,"MONOCHROME2");

		list.insert(attribute);
	}
	{
		// ImageType

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				"ORIGINAL","PRIMARY","MPR");

		list.insert(attribute);
	}
	{
		// ScanningSequence
		// SequenceVariant
		// ScanOptions

		DC3Tag ScanningSequencetag (DC3ScanningSequence_GROUP,
			    DC3ScanningSequence_ELEMENT);
		DC3CodeString *ScanningSequence =
			new DC3CodeString(ScanningSequencetag,0);

		DC3Tag SequenceVarianttag (DC3SequenceVariant_GROUP,
			    DC3SequenceVariant_ELEMENT);
		DC3CodeString *SequenceVariant =
			new DC3CodeString(SequenceVarianttag,0);

		DC3Tag ScanOptionstag (DC3ScanOptions_GROUP,
			    DC3ScanOptions_ELEMENT);
		DC3CodeString *ScanOptions =
			new DC3CodeString(ScanOptionstag,0);
		
		if (strncmp(gbs_FLIP_FLAG.toSH(),"TI",2) == 0) {
			ScanningSequence->add("IR");
		}
		else if (strncmp(gbs_FLIP_FLAG.toSH(),"FI",2) == 0) {
			ScanningSequence->add("GR");
		}
		else if (strncmp(gbs_FLIP_FLAG.toSH(),"FL",2) == 0) {
			ScanningSequence->add("GR");
			SequenceVariant->add("SP");
		}
		else if (strncmp(gbs_FLIP_FLAG.toSH(),"FA",2) == 0) {
			ScanningSequence->add("GR");
			SequenceVariant->add("SS");
		}
		else {
			ScanningSequence->add("SE");
		}

		if (gbs_GATING_MODE.toUS() & 1<<0) {	// RESP - Resp Gated
			ScanOptions->add("RG");
		}
		if (gbs_GATING_MODE.toUS() & 1<<1) {	// EG - ECG Gated
			ScanOptions->add("CG");
		}

		if (strncmp(gbs_TECHNIQUE.toSH(),"W ",2) == 0) {
			ScanOptions->add("FS");
		}
		if (strncmp(gbs_TECHNIQUE.toSH(),"F ",2) == 0) {
			ScanOptions->add("FS");
		}

		SequenceVariant->first();
		if (!SequenceVariant->ismore())
			SequenceVariant->add("NONE");

		list.insert(ScanningSequence);
		list.insert(SequenceVariant);
		list.insert(ScanOptions);
	}
	{
		// MRAcquisitionType

		DC3Tag tag (DC3MRAcquisitionType_GROUP,
			    DC3MRAcquisitionType_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromString(tag,
				(gbs_3DRESOLUTION.toUS() > 1) ? "3D" : "2D");

		list.insert(attribute);
	}
	{
		// EchoTrainLength = ""

		DC3Tag tag (DC3EchoTrainLength_GROUP,
			    DC3EchoTrainLength_ELEMENT);

		DC3IntegerString *attribute =
			MakeIntegerStringEmpty(tag);

		list.insert(attribute);
	}
