/* ge98man2.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// PixelSpacing - valid for scouts also

		double spacing;
		spacing=CT98_ReconPixelSize.todouble();

		DC3Tag tag (DC3PixelSpacing_GROUP,
			    DC3PixelSpacing_ELEMENT);

		DC3DecimalString *attribute =
			MakeDecimalStringFromTwoDouble(tag,
				spacing,spacing);

		list.insert(attribute);
	}

	{
		// FilterType

		DC3Tag tag (DC3FilterType_GROUP,
			    DC3FilterType_ELEMENT);
		char *str;
		switch (CT98_BowtieFilter.toUS()) {
			case 1:		str="BODY"; break;
			case 2:		str="HEAD"; break;
			case 3:		str="A"; break;
			default:	str=""; break;
		}
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// RotationDirection

		DC3Tag tag (DC3RotationDirection_GROUP,
			    DC3RotationDirection_ELEMENT);
		char *str;
		switch (CT98_RotationDirection.toUS()) {
			case 1:		str="CW"; break;
			case 2:		str="CC"; break;
			default:	str=""; break;
		}
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// ExposureTime

		Uint16 exposuretime =
			(Uint16)(CT98_ScanTime.todouble() * 1000.0);

		DC3Tag tag (DC3ExposureTime_GROUP,
			    DC3ExposureTime_ELEMENT);
		char str[10];		// should be enough for Uint16 string
		ostrstream ost(str,10);
		ost << dec << exposuretime << '\0';
		DC3IntegerString *attribute =
			new DC3IntegerString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Exposure

		Uint16 exposure =
			(Uint16)(CT98_ScanTime.todouble()
				*CT98_TubeCurrent.toUS());

		DC3Tag tag (DC3Exposure_GROUP,
			    DC3Exposure_ELEMENT);
		char str[10];		// should be enough for Uint16 string
		ostrstream ost(str,10);
		ost << dec << exposure << '\0';
		DC3IntegerString *attribute =
			new DC3IntegerString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// WindowCenter

		Uint16 center = CT98_LevelSetting.toUS();
		if (center != 0) {
			DC3Tag tag (DC3WindowCenter_GROUP,
			    DC3WindowCenter_ELEMENT);
			char str[10];	// should be enough for Uint16 string
			ostrstream ost(str,10);
			ost << dec << center << '\0';
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// WindowWidth

		Uint16 width = CT98_WindowSetting.toUS();
		if (width != 0xffff && width != 0) {
			DC3Tag tag (DC3WindowWidth_GROUP,
			    DC3WindowWidth_ELEMENT);
			char str[10];	// should be enough for Uint16 string
			ostrstream ost(str,10);
			ost << dec << width << '\0';
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// BitsStored

		DC3Tag tag (DC3BitsStored_GROUP,
			    DC3BitsStored_ELEMENT);
		Uint16 i = CT98_DataRange.toUS();
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// HighBit

		DC3Tag tag (DC3HighBit_GROUP,
			    DC3HighBit_ELEMENT);
		Uint16 i = CT98_DataRange.toUS() - 1;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}

	// Do the constant stuff ...

	{
		// Manufacturer = "GENERAL ELECTRIC"

		DC3Tag tag (DC3Manufacturer_GROUP,
			    DC3Manufacturer_ELEMENT);
		char *str = "GENERAL ELECTRIC";
		DC3LongString *attribute =
			new DC3LongString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Modality = CT

		DC3Tag tag (DC3Modality_GROUP,
			    DC3Modality_ELEMENT);
		char *str = "CT";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PixelPaddingValue = 0

		DC3Tag tag (DC3PixelPaddingValue_GROUP,
			    DC3PixelPaddingValue_ELEMENT);
		Uint16 i = 0;
		DC3UnspecifiedShort *attribute =
			new DC3UnspecifiedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// BitsAllocated = 16

		DC3Tag tag (DC3BitsAllocated_GROUP,
			    DC3BitsAllocated_ELEMENT);
		Uint16 i = 16;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PixelRepresentation = 0 (unsigned)

		DC3Tag tag (DC3PixelRepresentation_GROUP,
			    DC3PixelRepresentation_ELEMENT);
		Uint16 i = 0;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// SamplesPerPixel = 1

		DC3Tag tag (DC3SamplesPerPixel_GROUP,
			    DC3SamplesPerPixel_ELEMENT);
		Uint16 i = 1;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PhotometricInterpretation = MONOCHROME2

		DC3Tag tag (DC3PhotometricInterpretation_GROUP,
			    DC3PhotometricInterpretation_ELEMENT);
		char *str = "MONOCHROME2";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// RescaleIntercept = 0

		DC3Tag tag (DC3RescaleIntercept_GROUP,
			    DC3RescaleIntercept_ELEMENT);
		char *str = "0";
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// RescaleSlope = 1

		DC3Tag tag (DC3RescaleSlope_GROUP,
			    DC3RescaleSlope_ELEMENT);
		char *str = "1";
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(str),str);
		list.insert(attribute);
	}
