/* genman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// AccessionNumber = ""

		char *str = "";
		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientSex = ""

		DC3Tag tag (DC3PatientSex_GROUP,
			    DC3PatientSex_ELEMENT);
		char *str;
		switch (GENESIS_EX_patsex.toUS()) {
			case 1:		str="M"; break;
			case 2:		str="F"; break;
			default:	str="";  break;
		}
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);
		char *str = "";
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientAge

		// handles DWMY suffix & is fixed length of 4

		DC3Tag tag (DC3PatientAge_GROUP,
			    DC3PatientAge_ELEMENT);
		char *str = GENESIS_EX_patage.toSH();
		char agestr[5];
		ostrstream ost(agestr,5);
		ost << setfill('0') << setw(3) << dec << atoi(str);
		switch (GENESIS_EX_patian.toUS()) {
			case 0:	agestr[3]='Y'; break;
			case 1:	agestr[3]='M'; break;
			case 2:	agestr[3]='D'; break;
			case 3:	agestr[3]='W'; break;
			default: agestr[3]=0; break;
		}
		agestr[4]=0;
		
		DC3AgeString *attribute =
			new DC3AgeString(tag,4,agestr);
		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);
		char *str = "";
		if (isct) str = DC3CTImageStorageSOPClass;
		if (ismr) str = DC3MRImageStorageSOPClass;
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPInstanceUID

		unsigned imagenumber=0;
		if (isct) imagenumber = GENESIS_CT_im_no.toUS();
		if (ismr) imagenumber = GENESIS_MR_im_no.toUS();
		DC3GeneratedSOPInstanceUID uid
			(stamp,GENESIS_EX_ex_no.toUS(),
			       GENESIS_SE_se_no.toUS(),
			       imagenumber);
		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid
			 (stamp,GENESIS_EX_ex_no.toUS());
		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid
			(stamp,GENESIS_EX_ex_no.toUS(),
			       GENESIS_SE_se_no.toUS());
		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid
			(stamp,GENESIS_EX_ex_no.toUS(),
			       GENESIS_SE_se_no.toUS());
		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		ImagePlaneHeadFeet headfeet;

		switch (GENESIS_SE_entry.toUS()) {
			case 1:
					hfff="HF";
					headfeet=HeadFirst;
					break;
			case 2:
					hfff="FF";
					headfeet=FeetFirst;
					break;
			default:	hfff="";		// :(
					headfeet=HeadFirst;
					break;
		}

		ImagePlanePosition position;

		switch (GENESIS_SE_position.toUS()) {	// bitmap
			case 1:
					ap="S";
					position=Supine;
					break;
			case 2:
					ap="P";
					position=Prone;
					break;
			case 4:
					ap="DL";
					position=LeftLateralDecubitus;
					break;
			case 8:
					ap="DR";
					position=RightLateralDecubitus;
					break;
			default:	ap="";			// :(
					position=Supine;
					break;
		}

		ImagePlane imageplane(headfeet,position);

		// get common definitions for CT or MR

		double tlhc_R;
		double tlhc_A;
		double tlhc_S;
		double trhc_R;
		double trhc_A;
		double trhc_S;
		double brhc_R;
		double brhc_A;
		double brhc_S;
		if (isct) {
			tlhc_R		=GENESIS_CT_tlhc_R.todouble();
			tlhc_A		=GENESIS_CT_tlhc_A.todouble();
			tlhc_S		=GENESIS_CT_tlhc_S.todouble();
			trhc_R		=GENESIS_CT_trhc_R.todouble();
			trhc_A		=GENESIS_CT_trhc_A.todouble();
			trhc_S		=GENESIS_CT_trhc_S.todouble();
			brhc_R		=GENESIS_CT_brhc_R.todouble();
			brhc_A		=GENESIS_CT_brhc_A.todouble();
			brhc_S		=GENESIS_CT_brhc_S.todouble();
		}
		if (ismr) {
			tlhc_R		=GENESIS_MR_tlhc_R.todouble();
			tlhc_A		=GENESIS_MR_tlhc_A.todouble();
			tlhc_S		=GENESIS_MR_tlhc_S.todouble();
			trhc_R		=GENESIS_MR_trhc_R.todouble();
			trhc_A		=GENESIS_MR_trhc_A.todouble();
			trhc_S		=GENESIS_MR_trhc_S.todouble();
			brhc_R		=GENESIS_MR_brhc_R.todouble();
			brhc_A		=GENESIS_MR_brhc_A.todouble();
			brhc_S		=GENESIS_MR_brhc_S.todouble();
		}

		// DICOM plane definitions are:
		// - Left Pos Superior +ve

		// The Genesis co-ordinates are:
		// - Right Ant Superior +ve
		// - Corners offset by center co-ordinates
		// - already account for offset from isocenter/reference

		// (NB. no effort is made to fix the sign of SliceLocation)

		// Change sign of AP and LR from Genesis to DICOM...

		Point3D TLHC(
			-tlhc_R,
			-tlhc_A,
			 tlhc_S
			);
		Point3D TRHC(
			-trhc_R,
			-trhc_A,
			 trhc_S
			);
		Point3D BRHC(
			-brhc_R,
			-brhc_A,
			 brhc_S
			);

		imageplane.PatientPlane::setCorners(TLHC,
						    TRHC-TLHC,	// Row Vector
						    BRHC-TRHC);	// Col Vector

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);
			ost << hfff << ap << '\0';
			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getTLHC().getX()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getY()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getRowVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePosition

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getTLHC().getX()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getY()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientation

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getRowVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// PatientOrientation

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);

			ost << imageplane.PatientPlane::getRowOrientation()
			    << "\\"
			    << imageplane.PatientPlane::getColOrientation()
			    << ends;

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// ImageType

		char *value1,*value2,*value3;

		switch (GENESIS_SE_se_typ.toUS()) {
			case 1:		// Prospective
					value1="ORIGINAL";
					value2="PRIMARY";
					if (isct) value3="AXIAL";
					if (ismr) value3="MPR";
					break;
			case 2:		// Retrospective
					value1="ORIGINAL";
					value2="SECONDARY";
					if (isct) value3="AXIAL";
					if (ismr) value3="MPR";
					break;
			case 3:		// Scout
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="LOCALIZER";	// CT IOD
					break;
			case 4:		// Reformatted
			case 5:		// Screensave
					value1="DERIVED";
					value2="SECONDARY";
					value3="OTHER";		// MR IOD
					break;
			case 6:		// Xenon
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="AXIAL";		// CT IOD
			case 7:		// Service
					value1="DERIVED";
					value2="SECONDARY";
					value3="OTHER";		// MR IOD
					break;
			case 9:		// Projected
					value1="DERIVED";
					value2="SECONDARY";
					value3="PROJECTION IMAGE"; // MR IOD
					break;
			default:
					value1="";
					value2="";
					value3="";
					break;
		}

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				value1,value2,value3);

		list.insert(attribute);
	}
	if (isct) {
		// ConvolutionKernel

		char *str;

		// supposed to be a bitmap - we will assume enum :(
		switch (GENESIS_CT_reconalg.toUS()) {
			case 1:		str="SMOOTH";
					break;
			case 2:		str="SOFT";
					break;
			case 4:		str="STANDARD";
					break;
			case 8:		str="DETAIL";
					break;
			case 16:	str="BONE";
					break;
			case 32:	str="EDGE";
					break;
			case 64:	str="SHARP";
					break;
			case 128:	str="EXP2";
					break;
			default:	str="";
					break;
		}

		// could also utilize CT_perisflag & CT_iboneflag ??

		DC3Tag tag (DC3ConvolutionKernel_GROUP,
			    DC3ConvolutionKernel_ELEMENT);
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
