/* genptrs.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

enum GENESIS_headerlayout_type { GENESIS_IMGF_layout, GENESIS_DAT_layout, GENESIS_AWCT_layout, GENESIS_AWMR_layout };

extern GENESIS_headerlayout_type GENESIS_headerlayout;

struct GENESIS_headerlayout_entry {
	unsigned suitehdr;
	unsigned examhdr;
	unsigned serieshdr;
	unsigned imagehdr;
	unsigned filehdr;
};

extern struct GENESIS_headerlayout_entry GENESIS_headerlayout_table[];

	// hopefully the following keywords will be encountered before
	// they are used :)

#define isct	(GENESIS_headerlayout == GENESIS_AWCT_layout || (GENESIS_headerlayout != GENESIS_AWMR_layout && strcmp(GENESIS_EX_ex_typ.toSH(),"CT") == 0))
#define ismr	(GENESIS_headerlayout == GENESIS_AWMR_layout || (GENESIS_headerlayout != GENESIS_AWCT_layout && strcmp(GENESIS_EX_ex_typ.toSH(),"MR") == 0))

// The DAT file has the suite,exam,series & image headers up front
// at fixed locations, then the "real" file header starts ...

#define GENESIS_FILEHDR_ptr		(GENESIS_headerlayout_table[(unsigned)GENESIS_headerlayout].filehdr)
#define GENESIS_FILEHDR_lng		156
#define GENESIS_UNPACKHDR_ptr		(GENESIS_FILEHDR_ptr+GENESIS_IH_img_p_unpack.toUS())
#define GENESIS_UNPACKHDR_lng		GENESIS_IH_img_l_unpack.toUS()
#define GENESIS_HISTHDR_ptr		(GENESIS_FILEHDR_ptr+GENESIS_IH_img_p_histo.toUS())
#define GENESIS_HISTHDR_lng		GENESIS_IH_img_l_histo.toUS()
#define GENESIS_SUITEHDR_ptr		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? GENESIS_headerlayout_table[(unsigned)GENESIS_headerlayout].suitehdr	: GENESIS_IH_img_p_suite.toUS())
#define GENESIS_SUITEHDR_lng		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? 114	: GENESIS_IH_img_l_suite.toUS())
#define GENESIS_EXAMHDR_ptr		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? GENESIS_headerlayout_table[(unsigned)GENESIS_headerlayout].examhdr	: GENESIS_IH_img_p_exam.toUS())
#define GENESIS_EXAMHDR_lng		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? 1024	: GENESIS_IH_img_l_exam.toUS())
#define GENESIS_SERIESHDR_ptr		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? GENESIS_headerlayout_table[(unsigned)GENESIS_headerlayout].serieshdr	: GENESIS_IH_img_p_series.toUS())
#define GENESIS_SERIESHDR_lng		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? 1020	: GENESIS_IH_img_l_series.toUS())

#define GENESIS_IMAGEHDR_ptr		((GENESIS_headerlayout != GENESIS_IMGF_layout) ? GENESIS_headerlayout_table[(unsigned)GENESIS_headerlayout].imagehdr	: GENESIS_IH_img_p_image.toUS())

#define GENESIS_CTHDR_ptr		GENESIS_IMAGEHDR_ptr
#define GENESIS_CTHDR_lng		(isct?((GENESIS_headerlayout != GENESIS_IMGF_layout) ? 1020 : GENESIS_IH_img_l_image.toUS()):0)
#define GENESIS_MRHDR_ptr		GENESIS_IMAGEHDR_ptr
#define GENESIS_MRHDR_lng		(ismr?((GENESIS_headerlayout != GENESIS_IMGF_layout) ? 1022 : GENESIS_IH_img_l_image.toUS()):0)

// For some reason the DAT version of GENESIS_IH_img_hdr_length is too short by 4 bytes :(

#define GENESIS_IMAGEDATA_ptr		(GENESIS_FILEHDR_ptr + GENESIS_IH_img_hdr_length.toUS() + ((GENESIS_headerlayout == GENESIS_DAT_layout) ? 4 : 0) )

