/* s15ptdrc.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

#ifndef _s15ptdrc_HEADER_
#define _s15ptdrc_HEADER_

// This file defines the format of the PATIENT.DRC file that is
// the first file of a patient exam written on an Philips S15 MRI

// Initial Vax style String (length always seems to be == "0077") ...

#define InitialStringLength 77

#define InitialStringPatientNameLength	30
#define InitialStringPatientIdLength	20
#define InitialStringArchiveDateLength	12
#define InitialStringArchiveTimeLength	15

struct InitialString {
	char length[4];		// includes itself
	union {
		char string[InitialStringLength-4];
		struct {
			char PatientName [InitialStringPatientNameLength];
			char PatientId [InitialStringPatientIdLength];
			char ArchiveDate [InitialStringArchiveDateLength];	// "dd-mmm-yyyy "
			char ArchiveTime [InitialStringArchiveTimeLength];  // "hh-mm-ss.ffffff"
		} split;
	} u;
};

// Series of fixed fields ... each null terminated NOT Vax strings  ...

#define FixedFieldsLength 130

#define FixedFieldsPatientNameLength	21
#define FixedFieldsPatientIdLength	13
#define FixedFieldsDobLength		12
#define FixedFieldsScanDateLength	26
#define FixedFieldsAnnotation1Length	35
#define FixedFieldsAnnotation2Length	19

struct FixedFields {
	char length[4];		// includes itself
	char PatientName [FixedFieldsPatientNameLength];
	char PatientId [FixedFieldsPatientIdLength];
	char Dob [FixedFieldsDobLength];			// "dd-mmm-yyyy"
	char ScanDate [FixedFieldsScanDateLength];		// "dd-mmm-yy" ????
	char Annotation1 [FixedFieldsAnnotation1Length];	// ? always indication
	char Annotation2 [FixedFieldsAnnotation2Length];	// ? always region
};

#define FileNameEntryLength 13

struct FileNameEntry {
	char length[4];		// includes itself
	char string[FileNameEntryLength-4];
};

// No obvious terminator for FileNameEntry list,
// but rest of record fileed with 0x5e


#endif /* _s15ptdrc_HEADER_ */
