/* paceman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);
		char *str = "";
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);
		char *str = "";
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientAge

		DC3Tag tag (DC3PatientAge_GROUP,
			    DC3PatientAge_ELEMENT);
		char *str = PACE_SAGE.toSH();	// yyy;mm
		unsigned yyy=atoi(str);
		unsigned mm=atoi(str+4);

		ostrstream ost;
		if (yyy)
			ost << setw(3) << setfill('0')
			    << yyy << 'Y' << ends;	// blow off months
		else
			ost << setw(3) << setfill('0')
			    << mm  << 'M' << ends;	// a baby presumably

		char *agestr=ost.str();
		DC3AgeString *attribute =
			new DC3AgeString(tag,strlen(agestr),agestr);
		list.insert(attribute);
	}
	{	// SOPClassUID

		char *uid;
		char *modality;
		switch (PACE_SMODELNO_Mod.toUS()) {
			case 1:
				uid=DC3CTImageStorageSOPClass;
				modality="CT";
				break;
			case 2:
				uid=DC3MRImageStorageSOPClass;
				modality="MR";
				break;
			default:
				// this is very bad :(
				uid=0;
				modality=0;
				break;
		}
		if (uid) {
			DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);
			DC3UIString *attribute =
				new DC3UIString(tag,strlen(uid),uid);
			list.insert(attribute);
		}
		if (modality) {
			DC3Tag tag (DC3Modality_GROUP,
				    DC3Modality_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(modality),
					modality);
			list.insert(attribute);
		}
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,PACE_ISTUDYNO.toUS(),
			       PACE_ISERNO.toUS(),
			       PACE_IIMGNO.toUS());
		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid
			 (stamp,PACE_ISTUDYNO.toUS());
		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid
			(stamp,PACE_ISTUDYNO.toUS(),
			       PACE_ISERNO.toUS());
		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid
			(stamp,PACE_ISTUDYNO.toUS(),
			       PACE_ISERNO.toUS());
		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}

	{
		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		ImagePlanePlane plane;

		// Determine the "machine" plane of the image ...

		{
			// (Doesn't handle scout azimuth yet)
			// Same for CT and MR (CT seems to set IMTYPE "AX  ")
			switch (PACE_IPLANE.toCS()[0]) {
				case 'A':	// "AX  "
					plane=Axial;
					break;
				case 'S':	// "SAG "
					plane=Sagittal;
					break;
				case 'C':	// "COR "
					plane=Coronal;
					break;
				default:	// Yuck - just in case :(
					plane=Axial;
					break;
			}
		}

		ImagePlaneHeadFeet orientation;

		switch (PACE_IHFFIRST.toCS()[0]) {
			case 'H':
					hfff="HF";
					orientation=HeadFirst;
					break;
			case 'F':
					hfff="FF";
					orientation=FeetFirst;
					break;
			default:	hfff="";		// :(
					orientation=HeadFirst;
					break;
		}

		ImagePlanePosition position;

		switch (PACE_IPATORI.toCS()[0]) {
			case 'P':
					ap="P";
					position=Prone;
					break;
			case 'S':
					ap="S";
					position=Supine;
					break;
			case 'L':
					ap="DL";
					position=LeftLateralDecubitus;
					break;
			case 'R':
					ap="DR";
					position=RightLateralDecubitus;
					break;
			default:	ap="";			// :(
					position=Supine;
					break;
		}

		double scanfov = PACE_ISFOV.todouble()*10;	// cm -> mm

		// Make a model of the image plane ...

		ImagePlane imageplane(plane,scanfov,orientation,position);

		// While we are in the "display" or "gantry plane ...
		// (before angulation) 

		// Apply any transformations specified in the
		// display/gantry plane, such as magnification and
		// reconstruction target offsets ...

		// Assume that these are machine rather than body relative

		double reconfov	= PACE_IRFOV.todouble()*10;	// cm -> mm
		double reconch	= PACE_IRCENTX.todouble();
		double reconcv	= PACE_IRCENTY.todouble();

		double magfact 	= PACE_IMAGFACT.todouble();
		double magch	= PACE_IMAGCX.todouble();
		double magcv	= PACE_IMAGCY.todouble();

		Vector3D reconoffset;
		Vector3D magoffset;

		// Determine which axes are "horizontal" & "vertical" ...
		// Don't forget sign changes ...

		switch (plane) {
			case Axial:
				reconoffset=Vector3D(reconch,-reconcv,0);
				magoffset  =Vector3D(magch,    -magcv,0);
				break;
			case Sagittal:
				reconoffset=Vector3D(0,-reconch,reconcv);
				magoffset  =Vector3D(0,  -magch,  magcv);
				break;
			case Coronal:
				reconoffset=Vector3D(reconch,0,reconcv);
				magoffset  =Vector3D(magch  ,0,  magcv);
				break;
		}

		imageplane.MachinePlane::scale(magfact*reconfov/scanfov);
		imageplane.MachinePlane::shift(reconoffset);
		imageplane.MachinePlane::shift(magoffset);

		// Account for angulation ...

		if (isct()) {
#ifdef PACETILTCTUSINGMACHINECORDS
			// +ve is top towards table
			// whereas Z is positive into gantry so change sign
			imageplane.MachinePlane::angle(
				LeftRight,-PACE_IGTILT.todouble());
#else // PACETILTCTUSINGMACHINECORDS
			// +ve is always towards front of head
			imageplane.PatientPlane::angle(
				LeftRight,PACE_IGTILTB.todouble());
#endif // PACETILTCTUSINGMACHINECORDS
		}

		if (ismr()) {
			// Not yet tested ... no samples available ...

			// Tilt is specified as none or relative to axis
			// Axis+/-Angle [xx+/-xx]
			// NB. in body not machine coordinates **********

			char *str=PACE_IMRTILT.toSH();
			char axis[3]; strncpy(axis,str,2); axis[2]=0;
			int angle=str[2] ? atoi(str+2) : 0;

			// in Japanese docs, text contradicts drawing so
			// go with drawing ...

			ImagePlaneAxis planeaxis;

			if (angle) {
				switch (axis[0]) {
					case 'A':
					case 'P':
						planeaxis=AnteriorPosterior;
						// Pace CW +ve facing posterior
						// angle=angle;
						break;
					case 'R':
					case 'L':
						planeaxis=LeftRight;
						// Pace CW +ve facing right lat
						angle=-angle;
						break;
					case 'H':
					case 'F':
						planeaxis=HeadFeet;
						// Pace CW +ve facing head
						// angle=angle;
						break;
				}
			}
			imageplane.PatientPlane::angle(planeaxis,angle);
		}

		// Account for physical offsets in the body plane ...
		// (after angulation)

		// For Pace the only difference between slices seems to be
		// in the "Slice position by body coords" (ISLPOSxx) fields
		// These do NOT include recon center offset and gantry tilt

		// NB. The "Image center machine coords" (IIMPOSx) already
		// account for both the recon center offset and the gantry
		// tilt. They do NOT however handle the change between
		// slices in the Z direction (what I would expect to be
		// in ITBLPOS but is not ... it is zero in every slice :()
		// so we can't use them.

		{
			double xcenter=PACE_ISLPOSLR.todouble();
			double ycenter=PACE_ISLPOSAP.todouble();
			double zcenter=PACE_ISLPOSHF.todouble();

			// Consider sign difference Pace vs. Dicom for Y

			Vector3D offset(xcenter,-ycenter,zcenter);
			imageplane.PatientPlane::shift(offset);
		}

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);
			ost << hfff << ap << '\0';
			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getTLHC().getX()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getY()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getRowVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePosition

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getTLHC().getX()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getY()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientation

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getRowVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// PatientOrientation

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);

			ost << imageplane.PatientPlane::getRowOrientation()
			    << "\\"
			    << imageplane.PatientPlane::getColOrientation()
			    << ends;

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// SliceLocation

			// ITBLPOS always seems to be zero, so use IPLANE to
			// decide which slice position value to use

			// Pace slice position values are in body coordinates.
			// Neither DICOM PS3 nor ACR/NEMA 2 define sign of
			// SliceLocation, but seeing as it is an old element
			// it seems appropriate to use machine coordinates

			// Don't want to use the angled, magnified, targeted
			// imageplane because it is in the axis of the
			// image center rather than the axis at isocenter
			// and is slightly different from the conventional
			// interpretation of table position if an offset
			// in the display/gantry plane has been applied.

			// So set up a new imageplane just to convert from
			// body to machine cordinates, and apply physical
			// offset without angulation or recon or zoom ...

			ImagePlane locationimageplane(
				plane,scanfov,orientation,position);

			double xcenter=PACE_ISLPOSLR.todouble();
			double ycenter=PACE_ISLPOSAP.todouble();
			double zcenter=PACE_ISLPOSHF.todouble();

			Vector3D offset(xcenter,-ycenter,zcenter);
			locationimageplane.PatientPlane::shift(offset);

			Point3D center=
				locationimageplane.MachinePlane::getCenter();

			double location;

			switch (plane) {
				case Axial:
					location=center.getZ();
					break;
				case Sagittal:
					location=center.getX();
					break;
				case Coronal:
					location=center.getY();
					break;
			}

			ostrstream ost;
			ost << dec << location << ends;
			char *str=ost.str();

			DC3Tag tag (DC3SliceLocation_GROUP,
			  	  DC3SliceLocation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// TableHeight

		// DICOM ...+ve is below center
		// Pace is in machine co-ordinates ... +ve is up

		ostrstream ost;
		ost << dec << -PACE_ITBLHGT.todouble() << ends;
		char *str=ost.str();

		DC3Tag tag (DC3TableHeight_GROUP,
			    DC3TableHeight_ELEMENT);
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// ImageType

		char *value1,*value2,*value3;

		value1="ORIGINAL";

		// P is prospective, R is retrospective ...

		value2=strncmp(PACE_ITCTYPE.toCS(),"P",1) == 0
			? "PRIMARY" : "SECONDARY";

		value3=strncmp(PACE_IMTYPE.toCS(),"AX",2) == 0
			? "AXIAL" : "LOCALIZER";

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);
		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				value1,value2,value3);
		list.insert(attribute);
	}
	{
		// ContrastBolus Module

		if (strncmp(PACE_IENHANCE.toCS(),"+C",2) == 0) {
			{
				// ContrastBolusAgent =""

				DC3Tag tag (DC3ContrastBolusAgent_GROUP,
					    DC3ContrastBolusAgent_ELEMENT);
				char *str = "";
				DC3LongString *attribute =
					new DC3LongString(tag,strlen(str),str);
				list.insert(attribute);
			}
			{
				// ContrastBolusStartTime

				DC3Tag tag (DC3ContrastBolusStartTime_GROUP,
					    DC3ContrastBolusStartTime_ELEMENT);
				char *out = PACE_ICETIME.toTM();
				DC3TimeString *attribute =
					new DC3TimeString(tag,strlen(out),out);
				list.insert(attribute);
			}
		}
	}
