/* sgnman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);
		char *str = "";
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);
		char *str = "";
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientAge

		// handles DWMY suffix & is fixed length of 4

		DC3Tag tag (DC3PatientAge_GROUP,
			    DC3PatientAge_ELEMENT);
		char *str = SIGNA_PatientAge.toSH();
		char agestr[5];
		ostrstream ost(agestr,5);
		ost << setfill('0') << setw(3) << dec << atoi(str);
		if      (strchr(str,'d') || strchr(str,'D')) agestr[3]='D';
		else if (strchr(str,'w') || strchr(str,'W')) agestr[3]='W';
		else if (strchr(str,'m') || strchr(str,'M')) agestr[3]='M';
		else agestr[3]='Y';
		agestr[4]=0;
		
		DC3AgeString *attribute =
			new DC3AgeString(tag,4,agestr);
		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);
		char *str = DC3MRImageStorageSOPClass;
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,SIGNA_StudyNumber.toUS(),
			       SIGNA_SeriesNumber.toUS(),
			       SIGNA_ImageNumber.toUS());
		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid
			 (stamp,SIGNA_StudyNumber.toUS());
		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid
			(stamp,SIGNA_StudyNumber.toUS(),
			       SIGNA_SeriesNumber.toUS());
		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid
			(stamp,SIGNA_StudyNumber.toUS(),
			       SIGNA_SeriesNumber.toUS());
		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		ImagePlaneHeadFeet headfeet;

		switch (SIGNA_PatientPosition.toUS()) {
			case 0:
					hfff="HF";
					headfeet=HeadFirst;
					break;
			case 1:
					hfff="FF";
					headfeet=FeetFirst;
					break;
			default:	hfff="";		// :(
					headfeet=HeadFirst;
					break;
		}

		ImagePlanePosition position;

		switch (SIGNA_PatientOrientation.toUS()) {
			case 0:
					ap="S";
					position=Supine;
					break;
			case 1:
					ap="P";
					position=Prone;
					break;
			case 2:
					ap="DL";
					position=LeftLateralDecubitus;
					break;
			case 3:
					ap="DR";
					position=RightLateralDecubitus;
					break;
			default:	ap="";			// :(
					position=Supine;
					break;
		}

		ImagePlane imageplane(headfeet,position);

		// DICOM plane definitions are:
		// - Left Pos Superior +ve

		// The Signa co-ordinates are:
		// - Right Ant Superior +ve
		// - Superior offset by SliceLocation
		// - ???? Ant offset by TablePosition ????

		// Change Sign of LR,AP from Signa to DICOM...

		Point3D TLHC(
			-SIGNA_TLHC_R.todouble(),
			-SIGNA_TLHC_A.todouble(),
			 SIGNA_TLHC_S.todouble()
			);
		Point3D TRHC(
			-SIGNA_TRHC_R.todouble(),
			-SIGNA_TRHC_A.todouble(),
			 SIGNA_TRHC_S.todouble()
			);
		Point3D BLHC(
			-SIGNA_BLHC_R.todouble(),
			-SIGNA_BLHC_A.todouble(),
			 SIGNA_BLHC_S.todouble()
			);

		imageplane.PatientPlane::setCorners(TLHC,
						    TRHC-TLHC,	// Row Vector
						    BLHC-TLHC);	// Col Vector

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);
			ost << hfff << ap << '\0';
			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getTLHC().getX()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getY()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getRowVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePosition

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getTLHC().getX()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getY()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientation

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getRowVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// PatientOrientation

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);

			ost << imageplane.PatientPlane::getRowOrientation()
			    << "\\"
			    << imageplane.PatientPlane::getColOrientation()
			    << ends;

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// ImageType

		char *value1,*value2,*value3;

		switch (SIGNA_SeriesType.toUS()) {
			case 0:		// Normal
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="MPR";
					break;
			case 1:		// Screensave
					value1="DERIVED";
					value2="PRIMARY";
					value3="MPR";
					break;
			case 2:		// Composite
					value1="DERIVED";
					value2="PRIMARY";
					value3="MPR";
					break;
			default:
					value1="";
					value2="";
					value3="";
					break;
		}

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);
		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				value1,value2,value3);
		list.insert(attribute);
	}
