/* sgnman2.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// StudyDate

		DC3Tag tag (DC3StudyDate_GROUP,
			    DC3StudyDate_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << "19" << setw(2) << SIGNA_StudyDateYear.toUS()
		    << setw(2) << SIGNA_StudyDateMonth.toUS()
		    << setw(2) << SIGNA_StudyDateDay.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// StudyTime

		DC3Tag tag (DC3StudyTime_GROUP,
			    DC3StudyTime_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << setw(2) << SIGNA_StudyTimeHour.toUS()
		    << setw(2) << SIGNA_StudyTimeMin.toUS()
		    << setw(2) << SIGNA_StudyTimeSec.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3TimeString *attribute =
			new DC3TimeString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// SeriesDate

		DC3Tag tag (DC3SeriesDate_GROUP,
			    DC3SeriesDate_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << "19" << setw(2) << SIGNA_SeriesDateYear.toUS()
		    << setw(2) << SIGNA_SeriesDateMonth.toUS()
		    << setw(2) << SIGNA_SeriesDateDay.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// SeriesTime

		DC3Tag tag (DC3SeriesTime_GROUP,
			    DC3SeriesTime_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << setw(2) << SIGNA_SeriesTimeHour.toUS()
		    << setw(2) << SIGNA_SeriesTimeMin.toUS()
		    << setw(2) << SIGNA_SeriesTimeSec.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3TimeString *attribute =
			new DC3TimeString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// ImageDate

		DC3Tag tag (DC3ImageDate_GROUP,
			    DC3ImageDate_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << "19" << setw(2) << SIGNA_ImageDateYear.toUS()
		    << setw(2) << SIGNA_ImageDateMonth.toUS()
		    << setw(2) << SIGNA_ImageDateDay.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// ImageTime

		DC3Tag tag (DC3ImageTime_GROUP,
			    DC3ImageTime_ELEMENT);
		ostrstream ost;
		ost << dec << setfill('0')
		    << setw(2) << SIGNA_ImageTimeHour.toUS()
		    << setw(2) << SIGNA_ImageTimeMin.toUS()
		    << setw(2) << SIGNA_ImageTimeSec.toUS()
		    << '\0' << setfill(' ');
		char *out = ost.str();
		DC3TimeString *attribute =
			new DC3TimeString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// PatientWeight

		DC3Tag tag (DC3PatientWeight_GROUP,
			    DC3PatientWeight_ELEMENT);
		ostrstream ost;
		// see dgtypes.cc for discussion of this ...
		ost << dec << setiosflags(ios::fixed)
		    << setiosflags(ios::showpoint) << setprecision(6)
		    << (double)SIGNA_PatientWeightGrams.toUL()/1000.0
		    << '\0';
		char *out = ost.str();
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// PixelSpacing

		DC3Tag tag (DC3PixelSpacing_GROUP,
			    DC3PixelSpacing_ELEMENT);
		DC3DecimalString *attribute =
			MakeDecimalStringFromTwoDouble(tag,
				SIGNA_PixelSize.todouble(),
				SIGNA_PixelSize.todouble());
		list.insert(attribute);
	}
	{
		// MagneticFieldStrength

		DC3Tag tag (DC3MagneticFieldStrength_GROUP,
			    DC3MagneticFieldStrength_ELEMENT);
		ostrstream ost;
		// see dgtypes.cc for discussion of this ...
		ost << dec << setiosflags(ios::fixed)
		    << setiosflags(ios::showpoint) << setprecision(6)
		    << (double)SIGNA_MagneticFieldStrengthGauss.toUS()/10000.0
		    << '\0';
		char *out = ost.str();
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// RepetitionTime

		DC3Tag tag (DC3RepetitionTime_GROUP,
			    DC3RepetitionTime_ELEMENT);
		ostrstream ost;
		// see dgtypes.cc for discussion of this ...
		ost << dec << setiosflags(ios::fixed)
		    << setiosflags(ios::showpoint) << setprecision(6)
		    << SIGNA_RepetitionTimeUS.todouble()/1000.0
		    << '\0';
		char *out = ost.str();
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(out),out);
		list.insert(attribute);
	}
	{
		// EchoTime

		DC3Tag tag (DC3EchoTime_GROUP,
			    DC3EchoTime_ELEMENT);
		ostrstream ost;
		// see dgtypes.cc for discussion of this ...
		ost << dec << setiosflags(ios::fixed)
		    << setiosflags(ios::showpoint) << setprecision(6)
		    << SIGNA_EchoTimeUS.todouble()/1000.0
		    << '\0';
		char *out = ost.str();
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(out),out);
		list.insert(attribute);
	}
	switch (SIGNA_PulseSequence.toUS()) {	// Inversion recovery
		case 1:				// IR
		case 9:				// MPIRS
		case 10:			// MPIRI
		case 23:			// FMPIR
			{
			// InversionTime

			DC3Tag tag (DC3InversionTime_GROUP,
				    DC3InversionTime_ELEMENT);
			ostrstream ost;
			// see dgtypes.cc for discussion of this ...
			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << SIGNA_InversionTimeUS.todouble()/1000.0
			    << '\0';
			char *out = ost.str();
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(out),out);
			list.insert(attribute);
			}
			break;
		default:
			break;
	}
	{
		// ScanningSequence
		// SequenceVariant
		// ScanOptions

		DC3Tag ScanningSequencetag (DC3ScanningSequence_GROUP,
			    DC3ScanningSequence_ELEMENT);
		DC3CodeString *ScanningSequence =
			new DC3CodeString(ScanningSequencetag,0);

		DC3Tag SequenceVarianttag (DC3SequenceVariant_GROUP,
			    DC3SequenceVariant_ELEMENT);
		DC3CodeString *SequenceVariant =
			new DC3CodeString(SequenceVarianttag,0);

		DC3Tag ScanOptionstag (DC3ScanOptions_GROUP,
			    DC3ScanOptions_ELEMENT);
		DC3CodeString *ScanOptions =
			new DC3CodeString(ScanOptionstag,0);

		switch (SIGNA_PulseSequence.toUS()) {
			case 0:			// MEMP
					ScanningSequence->add("SE");
					break;
			case 1:			// IR
					ScanningSequence->add("IR");
					break;
			case 2:			// PS ? Partial saturation
						// -> not valid DICOM enum :(
					ScanningSequence->add("PS");
					break;
			case 3:			// RM
					ScanningSequence->add("RM");
					break;
			case 4:			// RMGE
					ScanningSequence->add("RM");
					break;
			case 5:			// GRE
					ScanningSequence->add("GR");
					break;
			case 6:			// VEMP
					ScanningSequence->add("SE");
					break;
			case 7:			// MPGR
					ScanningSequence->add("GR");
					break;
			case 8:			// MPGRV
					ScanningSequence->add("GR");
					break;
			case 9:			// MPIRS
					ScanningSequence->add("IR");
					break;
			case 10:		// MPIRI
					ScanningSequence->add("IR");
					break;
			case 11:		// 3D/GRE
					ScanningSequence->add("GR");
					break;
			case 12:		// CINE/GRE
					ScanningSequence->add("GR");
					break;
			case 13:		// SPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SP");
					break;
			case 14:		// SSFP
					ScanningSequence->add("GR");
					SequenceVariant->add("TRSS");
					break;
			case 15:		// CINE/SPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SP");
					break;
			case 16:		// 3D/SPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SP");
					break;
			case 17:		// FSE
					ScanningSequence->add("SE");
					SequenceVariant->add("SK");
					break;
			case 18:		// FVE
					ScanningSequence->add("SE");
					SequenceVariant->add("SK");
					break;
			case 19:		// FSPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SP");
					SequenceVariant->add("SK");
					break;
			case 20:		// FGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SK");
					break;
			case 21:		// FMPSPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SP");
					SequenceVariant->add("SK");
					break;
			case 22:		// FMPGR
					ScanningSequence->add("GR");
					SequenceVariant->add("SK");
					break;
			case 23:		// FMPIR
					ScanningSequence->add("IR");
					SequenceVariant->add("SK");
					break;
			case 24:		// PROBE.S
			case 25:		// PROBE.P
					break;
			default:	break;
		}

		if (SIGNA_GatingType.toUS() & 1<<0) {	// EG - ECG Gated
			ScanOptions->add("CG");
		}
		if (SIGNA_GatingType.toUS() & 1<<1) {	// RESP - Resp Gated
			ScanOptions->add("RG");
		}
		if (SIGNA_GatingType.toUS() & 1<<2) {	// RC - Resp Compensated
			ScanOptions->add("PER");
		}
		if (SIGNA_GatingType.toUS() & 1<<3) {	// FC - Flow Compensated
			ScanOptions->add("FC");
		}
		if (SIGNA_GatingType.toUS() & 1<<4) {	// CL
		}
#ifndef DOSATOPTIONHERE
		if (SIGNA_GatingType.toUS() & 1<<5) {	// ST - Sat parameters
			ScanOptions->add("SP");		// spatial presaturation
		}
#endif
		if (SIGNA_GatingType.toUS() & 1<<6) {	// PG - Periph Gated
			ScanOptions->add("PPG");
		}
		if (SIGNA_GatingType.toUS() & 1<<7) {	// NP - No Phase Wrap
			SequenceVariant->add("OSP");
		}
		if (SIGNA_GatingType.toUS() & 1<<8) {	// RF - ?
		}
		if (SIGNA_GatingType.toUS() & 1<<9) {	// RT - Rect FOV
		}
		if (SIGNA_GatingType.toUS() & 1<<10) {	// VB - Var Bandwidth
		}
		if (SIGNA_GatingType.toUS() & 1<<11) {	// ED - Ext Dynamic Rng
		}
		if (SIGNA_GatingType.toUS() & 1<<12) {	// PM - POMP
		}
		if (SIGNA_GatingType.toUS() & 1<<15) {	// MP - Multiplanar
		}

		switch (SIGNA_SuppTech.toUS()) {
			case 1:
				ScanOptions->add("FS");	// fat saturation
				break;
			case 2:
				ScanOptions->add("WS");	// water saturation
				break;			// not DICOM def term
			default:
				break;
		}
#ifdef DOSATOPTIONHERE
		if (SIGNA_Sat.toUS()) {			// if any bits set
			ScanOptions->add("SP");		// spatial presaturation
		}
#endif
		if (SIGNA_SCIC.toUS()) {
			ScanOptions->add("IIC");	// intensity correction
		}					// not DICOM def term

		if (SIGNA_FracEcho.toUS() & 1<<0) {
			ScanOptions->add("PFF");	// partial fourier freq
		}

		if (SIGNA_GatingType2.toUS() & 1<<0	// Inversion Recovery:IR
		 || SIGNA_GatingType2.toUS() & 1<<1) {	// Driven Equilibrium:DE
			SequenceVariant->add("MP");	// mag prepared
		}

		// DC3ListofStrings::GetValueMultiplicity()' is protected

		SequenceVariant->first();
		if (!SequenceVariant->ismore())
			SequenceVariant->add("NONE");

		list.insert(ScanningSequence);
		list.insert(SequenceVariant);
		list.insert(ScanOptions);
	}
	{
		// MRAcquisitionType

		DC3Tag tag (DC3MRAcquisitionType_GROUP,
			    DC3MRAcquisitionType_ELEMENT);
		char *str;
		switch(SIGNA_ImageMode.toUS()) {
			case 0:			// 2D single
			case 1:			// 2D multiple
				str="2D";
				break;
			case 2:			// 3D volume
				str="3D";
				break;
			case 3:			// Cine:Cine
			case 4:			// Spectroscopy:SPECT
			default:	str="";
				break;
		}
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PhaseEncodingDirection

		DC3Tag tag (DC3PhaseEncodingDirection_GROUP,
			    DC3PhaseEncodingDirection_ELEMENT);
		char *str;

		if (SIGNA_PFSwapped.toUS())	// Swap Phase/Frequency
			str="COL";
		else
			str="ROW";

		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// AngioFlag - source images

		DC3Tag tag (DC3AngioFlag_GROUP,
			    DC3AngioFlag_ELEMENT);
		char *str;

		int angio;
		if (SIGNA_VasMode.toUS())
			angio=1;
		else
			angio=0;

		// if any bits set ...

		int collapsed = SIGNA_VascCollapse.toUS() ? 1: 0;

		if (angio && !collapsed)
			str="Y";
		else
			str="N";

		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// EchoTrainLength

		unsigned etl=SIGNA_ETL.toUS();
		DC3Tag tag (DC3EchoTrainLength_GROUP,
			    DC3EchoTrainLength_ELEMENT);
		DC3IntegerString *attribute =
			etl
			? MakeIntegerStringFromUnsigned(tag,etl)
			: MakeIntegerStringEmpty(tag);
		list.insert(attribute);
	}

	// Do the constant stuff ...

	{
		// Manufacturer = "GENERAL ELECTRIC"

		DC3Tag tag (DC3Manufacturer_GROUP,
			    DC3Manufacturer_ELEMENT);
		char *str = "GENERAL ELECTRIC";
		DC3LongString *attribute =
			new DC3LongString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// ManufacturerModelName = "SIGNA"

		DC3Tag tag (DC3ManufacturerModelName_GROUP,
			    DC3ManufacturerModelName_ELEMENT);
		char *str = "SIGNA";
		DC3LongString *attribute =
			new DC3LongString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Modality = MR

		DC3Tag tag (DC3Modality_GROUP,
			    DC3Modality_ELEMENT);
		char *str = "MR";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// BitsAllocated = 16

		DC3Tag tag (DC3BitsAllocated_GROUP,
			    DC3BitsAllocated_ELEMENT);
		Uint16 i = 16;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// BitsStored = 12

		DC3Tag tag (DC3BitsStored_GROUP,
			    DC3BitsStored_ELEMENT);
		Uint16 i = 12;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// HighBit = 11

		DC3Tag tag (DC3HighBit_GROUP,
			    DC3HighBit_ELEMENT);
		Uint16 i = 11;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PixelRepresentation = 0 (unsigned)

		DC3Tag tag (DC3PixelRepresentation_GROUP,
			    DC3PixelRepresentation_ELEMENT);
		Uint16 i = 0;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// SamplesPerPixel = 1

		DC3Tag tag (DC3SamplesPerPixel_GROUP,
			    DC3SamplesPerPixel_ELEMENT);
		Uint16 i = 1;
		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// PhotometricInterpretation = MONOCHROME2

		DC3Tag tag (DC3PhotometricInterpretation_GROUP,
			    DC3PhotometricInterpretation_ELEMENT);
		char *str = "MONOCHROME2";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// RescaleIntercept = 0

		DC3Tag tag (DC3RescaleIntercept_GROUP,
			    DC3RescaleIntercept_ELEMENT);
		char *str = "0";
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// RescaleSlope = 1

		DC3Tag tag (DC3RescaleSlope_GROUP,
			    DC3RescaleSlope_ELEMENT);
		char *str = "1";
		DC3DecimalString *attribute =
			new DC3DecimalString(tag,strlen(str),str);
		list.insert(attribute);
	}
