# Offsets are in 8 bit bytes from 0
# Lengths are in intype words

# equipment parameters

block="BINHDR"	offset="0"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# id for somatom 3 image files
block="BINHDR"	offset="2"	intype="VAX_short"	inlength="1"	name="scanner"	dicomtype="?"	dicomtag="?"	enum="0=fremdanlage,1=evaluskop A,2=evaluskop B,9=siretom 1,10=siretom 2000,20=siretom 2000 E,100=somatom 1,110=somatom SD,120=somatom SF,200=somatom 2,210=somatom 2N,310=somatom DR1,312=somatom DR1-25,314=somatom DR1-SG,320=somatom DR2,322=somatom DR2-G,330=somatom DR3,332=somatom DR3-G,410=somatom 025-384,420=somatom 025-512,500=somatom DR3-H"      # scanner type
block="BINHDR"	offset="4"	intype="VAX_short"	inlength="1"	name="mainsfreq"	dicomtype="?"	dicomtag="?"	# mains frequency Hz
block="BINHDR"	offset="6"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# internal clock at scan start (hi)
block="BINHDR"	offset="8"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# internal clock at scan start (lo)
block="BINHDR"	offset="10"	intype="VAX_char"	inlength="8"	name="?"		dicomtype="?"	dicomtag="?"	# calibration time hh:mm:ss
block="BINHDR"	offset="18"	intype="VAX_char"	inlength="2"	name="softwareversion"	dicomtype="LO"	dicomtag="SoftwareVersion"	# version of scan programs
block="BINHDR"	offset="20"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# internal clock at series start (hi)
block="BINHDR"	offset="22"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# internal clock at series start (lo)
block="BINHDR"	offset="24"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	bitmap="0:without SRZ (only DR1),with SRZ (only DR1);1:pandaros,micromatic;2:11/44,11/24;3:image memory 512,image memory 256;4:512 detector channels,384 detector channels;5:normal detectors,high resolution detectors;6:gantry 017,gantry 026"             # configuration word
block="BINHDR"	offset="26"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# number of detector elements
block="BINHDR"	offset="28"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# angle difference between detectors * 1000
block="BINHDR"	offset="30"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# intensity monitor minimum
block="BINHDR"	offset="32"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# intensity monitor maximum
block="BINHDR"	offset="34"	intype="VAX_char"	inlength="32"	name="?"		dicomtype="?"	dicomtag="?"	# equipment serial number
block="BINHDR"	offset="66"	intype="VAX_char"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=raw data,'B'=256,'C'=512"	# archive mode 1
block="BINHDR"	offset="67"	intype="VAX_char"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="'0'=uncompressed,'2'=compressed"	# archive mode 2
block="BINHDR"	offset="68"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# datablock number
block="BINHDR"	offset="70"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# number of datablocks
block="BINHDR"	offset="72"	intype="VAX_short"	inlength="1"	keyword="matrixsize"	dicomtype="?"	dicomtag="?"	# matrix size 256/512 pixel
block="BINHDR"	offset="74"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# back projector number for 256 matrix size
block="BINHDR"	offset="76"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# ????
block="BINHDR"	offset="78"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# rohdaten-speciherun (temporary=1)
block="BINHDR"	offset="79"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# automatische bildasugabe (ja=1)
block="BINHDR"	offset="80"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# raw data device
block="BINHDR"	offset="82"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# raw data file number

# justage-parameter

block="BINHDR"	offset="96"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=no,1=yes" # image recall from BSP start
block="BINHDR"	offset="98"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# misalignment (360 degree field)
block="BINHDR"	offset="100"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# misalignment (240 degree field)
block="BINHDR"	offset="102"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# water equivalence factor
block="BINHDR"	offset="104"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="1=head,2=body"	# head/body flag
block="BINHDR"	offset="106"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="-1=scan,-2=reconstruction"	# pre-processing status
block="BINHDR"	offset="108"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="1=yes,-1=no"	# normalized
block="BINHDR"	offset="110"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="1=yes,-1=no"	# logarithmic
block="BINHDR"	offset="112"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# start angle
block="BINHDR"	offset="114"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# AK threshold S3
block="BINHDR"	offset="116"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# AK threshold S4
block="BINHDR"	offset="118"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# AK convolution kernel misalignment
block="BINHDR"	offset="120"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# AK convolution kernel divisor scale factor
block="BINHDR"	offset="122"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# AK noise class (1/2)
block="BINHDR"	offset="124"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# topogram offset (for image level)
block="BINHDR"	offset="126"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# topogram - weighting 1
block="BINHDR"	offset="128"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# topogram - weighting 2

# general measurement parameters

block="BINHDR"	offset="130"	intype="VAX_char"	inlength="1"	name="scanmodechar1"	dicomtype="?"	dicomtag="?"	enum="'P'=image data,'R'=raw data"	# scan mode
block="BINHDR"	offset="131"	intype="VAX_char"	inlength="1"	keyword="scanmodechar2"	dicomtype="?"	dicomtag="?"	enum="'0'=tomogram,'Q'=quick scan,'S'=serial scan(dynamic),'C'=cardiac scan,'T'=topgram,'X'=test picture,'H'=chronogram"	# scan mode
block="BINHDR"	offset="132"	intype="VAX_short"	inlength="1"	keyword="fov"		dicomtype="DS"	dicomtag="DataCollectionDiameter"	# field of view diameter mm
block="BINHDR"	offset="134"	intype="VAX_short"	inlength="1"	keyword="scantime10"	dicomtype="?"	dicomtag="?"	# scan time sec * 10
block="BINHDR"	offset="136"	intype="VAX_short"	inlength="1"	name="kv"		dicomtype="DS"	dicomtag="KVP"	# generator voltage kv
block="BINHDR"	offset="138"	intype="VAX_short"	inlength="1"	keyword="dose"		dicomtype="IS"	dicomtag="Exposure"	# dose mas
block="BINHDR"	offset="140"	intype="VAX_short"	inlength="1"	name="slicethickness"	dicomtype="DS"	dicomtag="SliceThickness"	# slice thickness mm
block="BINHDR"	offset="142"	intype="VAX_short"	inlength="1"	keyword="gantrytilt"	dicomtype="DS"	dicomtag="GantryDetectorTilt"	# gantry angle degrees
block="BINHDR"	offset="144"	intype="VAX_short"	inlength="1"	keyword="tableposn"	dicomtype="DS"	dicomtag="SliceLocation"	# table position mm
block="BINHDR"	offset="146"	intype="VAX_short"	inlength="1"	name="tableheight"	dicomtype="DS"	dicomtag="TableHeight"	# table height mm
block="BINHDR"	offset="148"	intype="VAX_short"	inlength="1"	keyword="scanmodebin"	dicomtype="?"	dicomtag="?"	enum="1=standard(360 degrees),2=quickscan(240 degrees),3=without rotation,4=topogram,5=chronogram"	# scan mode 
block="BINHDR"	offset="150"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="1=with,-1=without"	# reconstruction
block="BINHDR"	offset="152"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# image reconstruction memory (0=default)
block="BINHDR"	offset="154"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# accumulated patient dose mas
block="BINHDR"	offset="156"	intype="VAX_short"	inlength="1"	keyword="dualenergy"	dicomtype="?"	dicomtag="?"	enum="0=no,1=yes"	# dual energy

block="BINHDR"	offset="162"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# number or projections
block="BINHDR"	offset="164"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# rotation mode
block="BINHDR"	offset="166"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# pulse period duration
block="BINHDR"	offset="168"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="DS"	dicomtag="ScanArc"	# scan angle (240 or 360)
block="BINHDR"	offset="170"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="IS"	dicomtag="GeneratorPower"	# generator power kW
block="BINHDR"	offset="172"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# anode rotation Hz
block="BINHDR"	offset="174"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="175"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# monitor scan field
block="BINHDR"	offset="176"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# monitor pulse width
block="BINHDR"	offset="177"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# generator release
block="BINHDR"	offset="178"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="179"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="180"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# field shift
block="BINHDR"	offset="181"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# reduction of measurement freq
block="BINHDR"	offset="182"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="183"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="184"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# pulse width XP
block="BINHDR"	offset="185"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# pulse shift
block="BINHDR"	offset="186"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# scan parameter reserved
block="BINHDR"	offset="187"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# auto zero time
block="BINHDR"	offset="188"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# pulse width GCP
block="BINHDR"	offset="189"	intype="VAX_byte"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# delay
block="BINHDR"	offset="190"	intype="VAX_short"	inlength="1"	keyword="rotationdirection"	dicomtype="?"	dicomtag="?"	enum="1=clockwise,-1=counterclockwise"	# rotation direction

# special scan parameters

# serial (dynamic)

block="BINHDR_AXIAL"	offset="194"	intype="VAX_short"	inlength="1"	name="dyn_rotations"	dicomtype="?"	dicomtag="?"	# number of rotations
block="BINHDR_AXIAL"	offset="196"	intype="VAX_short"	inlength="1"	name="dyn_rotno"	dicomtype="?"	dicomtag="?"	# current rotation no
block="BINHDR_AXIAL"	offset="198"	intype="VAX_short"	inlength="1"	name="dyn_time"	dicomtype="?"	dicomtag="?"	# time offset secs
block="BINHDR_AXIAL"	offset="200"	intype="VAX_short"	inlength="1"	name="dyn_delay"	dicomtype="?"	dicomtag="?"	# delay to 1st image in sequence
block="BINHDR_AXIAL"	offset="202"	intype="VAX_short"	inlength="1"	name="dyn_reconmode"	dicomtype="?"	dicomtag="?"	# reconstruction mode (degrees)

# cardio

block="BINHDR_CARDIO"	offset="194"	intype="VAX_short"	inlength="1"	name="crd_rotations"	dicomtype="?"	dicomtag="?"	# number of rotations
block="BINHDR_CARDIO"	offset="196"	intype="VAX_short"	inlength="1"	name="crd_rotno"	dicomtype="?"	dicomtag="?"	# current rotation no
block="BINHDR_CARDIO"	offset="198"	intype="VAX_short"	inlength="1"	name="crd_dly1"	dicomtype="?"	dicomtag="?"	# radiation delay 1 %
block="BINHDR_CARDIO"	offset="200"	intype="VAX_short"	inlength="1"	name="crd_dly2"	dicomtype="?"	dicomtag="?"	# radiation delay 2 %
block="BINHDR_CARDIO"	offset="202"	intype="VAX_short"	inlength="1"	name="crd_length"	dicomtype="?"	dicomtag="?"	# radiation length %
block="BINHDR_CARDIO"	offset="204"	intype="VAX_short"	inlength="1"	name="crd_center"	dicomtype="?"	dicomtag="?"	# assessment center %
block="BINHDR_CARDIO"	offset="206"	intype="VAX_short"	inlength="1"	name="crd_rr"	dicomtype="?"	dicomtag="?"	# RR-interval (internal clock ticks)

# topogram

block="BINHDR_TOPO"	offset="194"	intype="VAX_short"	inlength="1"	name="top_length"	dicomtype="?"	dicomtag="?"	# topogram length mm
block="BINHDR_TOPO"	offset="196"	intype="VAX_short"	inlength="1"	keyword="top_angle"	dicomtype="?"	dicomtag="?"	# tube angle degrees
block="BINHDR_TOPO"	offset="198"	intype="VAX_short"	inlength="1"	name="top_advance"	dicomtype="?"	dicomtag="?"	enum="1=into gantry,-1=out of gantry"	# table advance
block="BINHDR_TOPO"	offset="200"	intype="VAX_short"	inlength="1"	name="top_xcorrect"	dicomtype="?"	dicomtag="?"	# correction factor for X axis
block="BINHDR_TOPO"	offset="202"	intype="VAX_short"	inlength="1"	name="top_xtfactor"	dicomtype="?"	dicomtag="?"	# topogram factor X axis * 1000

# test picture

block="BINHDR_TEST"	offset="194"	intype="VAX_short"	inlength="1"	name="test_type"	dicomtype="?"	dicomtag="?"	enum="0=pre-processed,1=raw data,-1=logarithmic non-normalized,-2=logarithmic normalized"	# type of test data

# dual-energy

block="BINHDR_DUAL"	offset="194"	intype="VAX_short"	inlength="1"	name="de_toplength"	dicomtype="?"	dicomtag="?"	# topogram length
block="BINHDR_DUAL"	offset="196"	intype="VAX_short"	inlength="1"	name="de_topangle"	dicomtype="?"	dicomtag="?"	# topogram angle degrees
block="BINHDR_DUAL"	offset="198"	intype="VAX_short"	inlength="1"	name="de_topadvance"	dicomtype="?"	dicomtag="?"	enum="1=into gantry,-1=out of gantry"	# topogram table advance
block="BINHDR_DUAL"	offset="200"	intype="VAX_char"	inlength="2"	name="de_filetype"	dicomtype="?"	dicomtag="?"	enum="'DE'=original file,'KH'=KV high,'KL'=KV low,'MH'=material high,'ML'=material low,'MO'=mono-energetic,'MI'=combination of high & low,'NE'=electron density,'ZE'=effective"	# type of raw data file
block="BINHDR_DUAL"	offset="202"	intype="VAX_short"	inlength="1"	name="de_lowkv"	dicomtype="?"	dicomtag="?"	# low generator KV
block="BINHDR_DUAL"	offset="204"	intype="VAX_short"	inlength="1"	name="de_lowwater"	dicomtype="?"	dicomtag="?"	# low KV water equivalence value
block="BINHDR_DUAL"	offset="206"	intype="VAX_char"	inlength="4"	name="de_tvalue"	dicomtype="?"	dicomtag="?"	# table value
block="BINHDR_DUAL"	offset="210"	intype="VAX_short"	inlength="1"	name="de_filter"	dicomtype="?"	dicomtag="?"	enum="0=without,1=filter 1,2=filter 2"	# filter
block="BINHDR_DUAL"	offset="212"	intype="VAX_short"	inlength="1"	name="de_hikvwfhi"	dicomtype="?"	dicomtag="?"	# MO: KEV, MI: high word of hi KV weight factor
block="BINHDR_DUAL"	offset="214"	intype="VAX_short"	inlength="1"	name="de_hikvwflo"	dicomtype="?"	dicomtag="?"	# MI: low word of high KV weight factor
block="BINHDR_DUAL"	offset="216"	intype="VAX_short"	inlength="1"	name="de_lokvwfhi"	dicomtype="?"	dicomtag="?"	# MI: high word of low KV weight factor
block="BINHDR_DUAL"	offset="218"	intype="VAX_short"	inlength="1"	name="de_lokvwflo"	dicomtype="?"	dicomtag="?"	# MI: low word of low KV weight factor

# reconstruction

block="BINHDR"	offset="222"	intype="VAX_short"	inlength="1"	name="scanfieldsize"	dicomtype="?"	dicomtag="?"	enum="1=small,2=large"	# scan field
block="BINHDR"	offset="224"	intype="VAX_short"	inlength="1"	keyword="zoomfactor10"	dicomtype="?"	dicomtag="?"	# zoom factor * 10
block="BINHDR"	offset="226"	intype="VAX_short"	inlength="1"	keyword="xcenter"	dicomtype="?"	dicomtag="?"	# X reconstruction center
block="BINHDR"	offset="228"	intype="VAX_short"	inlength="1"	keyword="ycenter"	dicomtype="?"	dicomtag="?"	# Y reconstruction center
block="BINHDR"	offset="230"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# zoom factor for BSP (2048:zoom)
block="BINHDR"	offset="232"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# convolution kernel (tomogram)
block="BINHDR"	offset="234"	intype="VAX_short"	inlength="1"	name="smoothing"		dicomtype="?"	dicomtag="?"	enum="1=yes,-1=no"	# smoothing
block="BINHDR"	offset="236"	intype="VAX_short"	inlength="1"	name="viewdirection"	dicomtype="?"	dicomtag="?"	enum="1=cranial,-1=caudal"	# viewing direction
block="BINHDR"	offset="238"	intype="VAX_byte"	inlength="1"	keyword="headposition"	dicomtype="?"	dicomtag="?"	enum="0=head first,1=feet first"	# patient position
block="BINHDR"	offset="239"	intype="VAX_byte"	inlength="1"	keyword="patientposition"	dicomtype="?"	dicomtag="?"	enum="0=supine,1=prone,2=right lateral decubitus,3=left lateral decubitus"	# patient position
block="BINHDR"	offset="240"	intype="VAX_short"	inlength="1"	name="highres"	dicomtype="?"	dicomtag="?"	enum="0=normal,1=highres,2=extended balancing,3=super highres"	# high resolution
block="BINHDR"	offset="242"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# special highres filter
block="BINHDR"	offset="244"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# duty cycle 2KV method
block="BINHDR"	offset="246"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# convolution kernel (topogram)
block="BINHDR"	offset="248"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# duty cycle chronogram
block="BINHDR"	offset="250"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=raw data from disk,1=raw data from BSP memory"	# source of BSP data in memory
block="BINHDR"	offset="252"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=normal,1=with special scaling for MTF"	# image rendition

# assessment parameters

block="BINHDR"	offset="256"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# rotation mirroring angle difference relative to original position
block="BINHDR"	offset="258"	intype="VAX_short"	inlength="1"	keyword="pixelsper10cm"	dicomtype="?"	dicomtag="?"	# pixels in 10 cm (depends on zoom factor and matrix)
block="BINHDR"	offset="260"	intype="VAX_char"	inlength="2"	keyword="manipulations"	dicomtype="?"	dicomtag="?"	enum="'CF'=cine format,'EX'=image expansion,'MI'=multiple image,'MR'=image mirror,'RT'=image rotate,'SH'=image shift,'XX'=multiply manipulated,'KS'=MR image"	# image manipulations
block="BINHDR"	offset="262"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="100=topogram,200=coronal slice,300=sagittal slice,400=unravel,400=tir"	# image processing ID
block="BINHDR"	offset="264"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# address of cut line for sagittal and coronal slice in pixels
block="BINHDR"	offset="266"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="IS"	dicomtag="AcquisitionNumber"	# scan number per patient
block="BINHDR"	offset="268"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=without error,1=with error"	# error code
block="BINHDR"	offset="270"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# ID of selected ROI levels

# special assessment parameters

# 1. cine

block="BINHDR_CINE"	offset="272"	intype="VAX_byte"	inlength="8"	name="cine_win1"	dicomtype="?"	dicomtag="?"	# window 1 for cine
block="BINHDR_CINE"	offset="280"	intype="VAX_byte"	inlength="8"	name="cine_win2"	dicomtype="?"	dicomtag="?"	# window 2 for cine
block="BINHDR_CINE"	offset="288"	intype="VAX_byte"	inlength="24"	name="cine_switch"	dicomtype="?"	dicomtag="?"	# switch parameter

# 2. multi-image

block="BINHDR_MULTI"	offset="272"	intype="VAX_short"	inlength="1"	name="multi_mconfig"	dicomtype="?"	dicomtag="?"	# memory configuration
block="BINHDR_MULTI"	offset="274"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# no of displayed single images
block="BINHDR_MULTI"	offset="276"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# side length of single images in display (X axis)
block="BINHDR_MULTI"	offset="278"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# side length of sub-image if applicable (X axis)
block="BINHDR_MULTI"	offset="280"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# start column of sub-image
block="BINHDR_MULTI"	offset="282"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# start row of sub-image

block="BINHDR"	offset="304"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="0=manual,-1=auto"	# auto windowing
block="BINHDR"	offset="306"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# number of lookup tables
block="BINHDR"	offset="308"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	enum="8=window A,4=window B,2=double window,1=highlighting"	# window mode
block="BINHDR"	offset="310"	intype="VAX_short"	inlength="1"	name="windowawidth"	dicomtype="DS"	dicomtag="WindowWidth"	# window width A
block="BINHDR"	offset="312"	intype="VAX_short"	inlength="1"	name="windowacenter"	dicomtype="DS"	dicomtag="WindowCenter"	# window center A
block="BINHDR"	offset="314"	intype="VAX_short"	inlength="1"	name="windowbwidth"	dicomtype="?"	dicomtag="?"	# window width B
block="BINHDR"	offset="316"	intype="VAX_short"	inlength="1"	name="windowbcenter"	dicomtype="?"	dicomtag="?"	# window center B
block="BINHDR"	offset="318"	intype="VAX_short"	inlength="1"	name="?"		dicomtype="?"	dicomtag="?"	# photography ID

# special cardio parameters

block="BINHDR"	offset="320"	intype="VAX_byte"	inlength="60"	name="?"		dicomtype="?"	dicomtag="?"	# R blip trigger pattern
block="BINHDR"	offset="380"	intype="VAX_byte"	inlength="30"	name="?"		dicomtype="?"	dicomtag="?"	# Reserved for expansion
block="BINHDR"	offset="410"	intype="VAX_byte"	inlength="60"	name="?"		dicomtype="?"	dicomtag="?"	# radiation trigger pattern

# equipment parameters

block="BINHDR"	offset="480"	intype="VAX_char"	inlength="12"	name="?"		dicomtype="?"	dicomtag="?"	# detector serial number

# ===============================================================================================================================

block="TEXTHDR"	offset="0"	intype="VAX_char"	inlength="14"	name="product"	dicomtype="LO"	dicomtag="ManufacturerModelName"	# product
block="TEXTHDR"	offset="15"	intype="VAX_char"	inlength="25"	name="hospitalname"	dicomtype="LO"	dicomtag="InstitutionName"	# hospital
block="TEXTHDR"	offset="40"	intype="VAX_char"	inlength="12"	name="patientno"	dicomtype="LO"	dicomtag="PatientID"	# patient number
block="TEXTHDR"	offset="53"	intype="VAX_char"	inlength="22"	name="patientname"	dicomtype="PN"	dicomtag="PatientName"	# patient name
block="TEXTHDR"	offset="80"	intype="VAX_char"	inlength="2"	keyword="datedd"	dicomtype="?"	dicomtag="?"	# date - day
block="TEXTHDR"	offset="83"	intype="VAX_char"	inlength="3"	keyword="datemmm"	dicomtype="?"	dicomtag="?"	# date - month
block="TEXTHDR"	offset="87"	intype="VAX_char"	inlength="2"	keyword="dateyy"	dicomtype="?"	dicomtag="?"	# date - year
block="TEXTHDR"	offset="97"	intype="VAX_char"	inlength="5"	name="orienttop"	dicomtype="?"	dicomtag="?"	enum="'RIGHT'=right,'LEFT'=left,'FRONT'=front,'BACK'=back,'UP'=up,'DOWN'=down"	# orientation of top of image
block="TEXTHDR"	offset="120"	intype="VAX_char"	inlength="2"	keyword="timehh"	dicomtype="?"	dicomtag="?"	# time - hour
block="TEXTHDR"	offset="123"	intype="VAX_char"	inlength="2"	keyword="timemm"	dicomtype="?"	dicomtag="?"	# time - minute
block="TEXTHDR"	offset="126"	intype="VAX_char"	inlength="2"	keyword="timess"	dicomtype="?"	dicomtag="?"	# time - second
block="TEXTHDR"	offset="156"	intype="VAX_char"	inlength="1"	name="positionheadchar"	dicomtype="?"	dicomtag="?"	enum="'H'=head first,'F'=feet first"	# head position
block="TEXTHDR"	offset="158"	intype="VAX_char"	inlength="2"	name="patientpositionchar"	dicomtype="?"	dicomtag="?"	enum="'SP'=supine,'PR'=prone,'RP'=right lateral decubitus,'LP'=left lateral decubitus"	# patient position
block="TEXTHDR"	offset="205"	intype="VAX_char"	inlength="4"	keyword="sliceno"	dicomtype="IS"	dicomtag="ImageNumber"	# slice number
block="TEXTHDR"	offset="236"	intype="VAX_char"	inlength="1"	name="orientright"	dicomtype="?"	dicomtag="?"	enum="'R'=right,'L'=left,'F'=front,'B'=back,'U'=up,'D'=down"	# orientation of right of image
block="TEXTHDR"	offset="723"	intype="VAX_char"	inlength="4"	name="scantimechar"	dicomtype="?"	dicomtag="?"		# scan time sec
block="TEXTHDR"	offset="763"	intype="VAX_char"	inlength="4"	name="kvchar"	dicomtype="?"	dicomtag="?"		# generator kv
block="TEXTHDR"	offset="803"	intype="VAX_char"	inlength="4"	name="dosechar"	dicomtype="?"	dicomtag="?"		# dose as
block="TEXTHDR"	offset="843"	intype="VAX_char"	inlength="4"	name="slicethicknesschar"	dicomtype="?"	dicomtag="?"	# slice thickness mm
block="TEXTHDR"	offset="883"	intype="VAX_char"	inlength="4"	name="gantrytiltchar"	dicomtype="?"	dicomtag="?"	# gantry tilt degrees
block="TEXTHDR"	offset="923"	intype="VAX_char"	inlength="4"	name="tableposnchar"	dicomtype="?"	dicomtag="?"		# table position mm
