/* sytman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// AcquisitionNumber = ImageNumber

		DC3Tag tag (DC3AcquisitionNumber_GROUP,
			    DC3AcquisitionNumber_ELEMENT);
		char str[10];		// should be enough for Uint16 string
		ostrstream ost(str,10);
		ost << dec << SYTEC_ImageNumber.toUS() << '\0';
		DC3IntegerString *attribute =
			new DC3IntegerString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);
		char *str = "";
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientSex = ""

		DC3Tag tag (DC3PatientSex_GROUP,
			    DC3PatientSex_ELEMENT);
		char *str = "";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);
		char *str = "";
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);
		char *str = DC3CTImageStorageSOPClass;
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,SYTEC_ExamNumber.toUS(),
			       SYTEC_SeriesNumber.toUS(),
			       SYTEC_ImageNumber.toUS());
		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid
			 (stamp,SYTEC_ExamNumber.toUS());
		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid
			(stamp,SYTEC_ExamNumber.toUS(),
			       SYTEC_SeriesNumber.toUS());
		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid
			(stamp,SYTEC_ExamNumber.toUS(),
			       SYTEC_SeriesNumber.toUS());
		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Trying to derive Image Plane Module ...

		// Don't know enough fields to decipher HF/FF supine/prone
		// so assume PatientPlane and MachinePlane are the same ...

		ImagePlane imageplane(HeadFirst,Supine);

		// DICOM plane definitions are:
		// - Left Pos Superior +ve

		// The Sytec co-ordinates are (assumed to be):
		// - Left Ant Superior +ve
		// - Corners offset by center co-ordinates
		// - already account for offset from isocenter/reference

		// (NB. no effort is made to fix the sign of SliceLocation)

		// Change sign of AP from Sytec to DICOM...

		Point3D TLHC(
			 SYTEC_TopLeftHandCornerX.todouble(),
			-SYTEC_TopLeftHandCornerY.todouble(),
			 SYTEC_TopLeftHandCornerZ.todouble()
			);
		Point3D TRHC(
			 SYTEC_TopRightHandCornerX.todouble(),
			-SYTEC_TopRightHandCornerY.todouble(),
			 SYTEC_TopRightHandCornerZ.todouble()
			);
		Point3D BLHC(
			 SYTEC_BottomLeftHandCornerX.todouble(),
			-SYTEC_BottomLeftHandCornerY.todouble(),
			 SYTEC_BottomLeftHandCornerZ.todouble()
			);

		imageplane.PatientPlane::setCorners(TLHC,
						    TRHC-TLHC,	// Row Vector
						    BLHC-TLHC);	// Col Vector

		{
			// PatientPosition

			//char str[10];	// Enough for longest combination !
			//ostrstream ost(str,10);
			//ost << hfff << ap << '\0';
			char *str = "";
			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getTLHC().getX()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getY()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getRowVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePosition

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getTLHC().getX()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getY()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientation

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getRowVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// PatientOrientation

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);

			ost << imageplane.PatientPlane::getRowOrientation()
			    << "\\"
			    << imageplane.PatientPlane::getColOrientation()
			    << ends;

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// ImageType

		char *value1,*value2,*value3;

		switch (SYTEC_ScanType.toUS()) {
			case 1:		// Prospective
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="AXIAL";
					break;
			case 3:		// Scout
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="LOCALIZER";
					break;
			default:
					value1="";
					value2="";
					value3="";
					break;
		}

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);
		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				value1,value2,value3);
		list.insert(attribute);
	}
