/* vsnman1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// ReferringPhysicianName = ""

		DC3Tag tag (DC3ReferringPhysicianName_GROUP,
			    DC3ReferringPhysicianName_ELEMENT);

		DC3PersonName *attribute = MakePersonNameEmpty(tag);

		list.insert(attribute);
	}
	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);

		DC3ShortString *attribute = MakeShortStringEmpty(tag);

		list.insert(attribute);
	}
	{
		// StudyID = "1"

		DC3Tag tag (DC3StudyID_GROUP,
			    DC3StudyID_ELEMENT);

		DC3ShortString *attribute =
			MakeShortStringFromString(tag,"1");

		list.insert(attribute);
	}
	{
		// PatientSex = ""

		DC3Tag tag (DC3PatientSex_GROUP,
			    DC3PatientSex_ELEMENT);

		DC3CodeString *attribute = MakeCodeStringEmpty(tag);

		list.insert(attribute);
	}

	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);

			DC3DateString *attribute =
				MakeDateStringFromThreeValues(tag,
					VISION_DOBYYYY.toUS()-1900,
					VISION_DOBMM.toUS(),
					VISION_DOBDD.toUS());

		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,DC3MRImageStorageSOPClass);

		list.insert(attribute);
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,1,1,VISION_TextImageNumber.toUS());

		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid(stamp,1);

		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid(stamp,1,1);

		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid(stamp,1,1);

		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);

		DC3UIString *attribute =
			MakeUIStringFromString(tag,uid.GetUID());

		list.insert(attribute);
	}
	{
		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		ImagePlaneHeadFeet headfeet;

		if (strstr(VISION_TextPatientPosition.toSH(),"H")) {
			hfff="HF";
			headfeet=HeadFirst;
		}
		else if (strstr(VISION_TextPatientPosition.toSH(),"F")) {
			hfff="FF";
			headfeet=FeetFirst;
		}
		else {
			hfff="";		// :(
			headfeet=HeadFirst;
		}

		ImagePlanePosition position;

		if (strstr(VISION_TextPatientPosition.toSH(),"SP")) {
			ap="S";
			position=Supine;
		}
		else if (strstr(VISION_TextPatientPosition.toSH(),"PR")) {
			ap="P";
			position=Prone;
		}
		else if (strstr(VISION_TextPatientPosition.toSH(),"RP")) {
			ap="DR";
			position=RightLateralDecubitus;
		}
		else if (strstr(VISION_TextPatientPosition.toSH(),"LP")) {
			ap="DL";
			position=LeftLateralDecubitus;
		}
		else {
			ap="";			// :(
			position=Supine;
		}

		// Should look for view direction 'CR'=cranial,'CU'=caudal
		// in case of transverse, default being cranial ??

		ImagePlane imageplane(headfeet,position);

		// get common definitions for CT or MR

		// DICOM plane definitions are:
		// - Left Pos Superior +ve (+ : H P L)

		// The Siemens center co-ordinates & vectors are:
		// - Left Ant Inferior +ve (annotated as + : F A L)
		// - already account for offset from isocenter
		// - already account for patient position

		Point3D Center(
			 VISION_CenterPointX.todouble(),
			-VISION_CenterPointY.todouble(),
			-VISION_CenterPointZ.todouble()
			);

		double RowLength = VISION_FOVRow.todouble();
		Vector3D Row(
			 VISION_RowVectorX.todouble()*RowLength,
			-VISION_RowVectorY.todouble()*RowLength,
			-VISION_RowVectorZ.todouble()*RowLength
			);

		double ColumnLength = VISION_FOVColumn.todouble();
		Point3D Column(
			 VISION_ColumnVectorX.todouble()*ColumnLength,
			-VISION_ColumnVectorY.todouble()*ColumnLength,
			-VISION_ColumnVectorZ.todouble()*ColumnLength
			);

		Point3D TLHC = Center - Row/2 - Column/2;

		imageplane.PatientPlane::setCorners(TLHC,Row,Column);

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);

			DC3CodeString *attribute =
				MakeCodeStringFromConcatTwoStrings(tag,
				hfff,ap);

			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromThreeDouble(tag,
				imageplane.PatientPlane::getTLHC().getX(),
				imageplane.PatientPlane::getTLHC().getY(),
				imageplane.PatientPlane::getTLHC().getZ());

			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromSixDouble(tag,
				imageplane.PatientPlane::getRowVector().getX(),
				imageplane.PatientPlane::getRowVector().getY(),
				imageplane.PatientPlane::getRowVector().getZ(),
				imageplane.PatientPlane::getColVector().getX(),
				imageplane.PatientPlane::getColVector().getY(),
				imageplane.PatientPlane::getColVector().getZ());

			list.insert(attribute);
		}
		{
			// ImagePosition

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromThreeDouble(tag,
				imageplane.MachinePlane::getTLHC().getX(),
				imageplane.MachinePlane::getTLHC().getY(),
				imageplane.MachinePlane::getTLHC().getZ());

			list.insert(attribute);
		}
		{
			// ImageOrientation

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);

			DC3DecimalString *attribute =
			    MakeDecimalStringFromSixDouble(tag,
				imageplane.MachinePlane::getRowVector().getX(),
				imageplane.MachinePlane::getRowVector().getY(),
				imageplane.MachinePlane::getRowVector().getZ(),
				imageplane.MachinePlane::getColVector().getX(),
				imageplane.MachinePlane::getColVector().getY(),
				imageplane.MachinePlane::getColVector().getZ());

			list.insert(attribute);
		}
		{
			// PatientOrientation

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);

			DC3CodeString *attribute =
				MakeCodeStringFromTwoStringValues(tag,
			(char *)(imageplane.PatientPlane::getRowOrientation()),
			(char *)(imageplane.PatientPlane::getColOrientation()));

			list.insert(attribute);
		}
	}
	{
		// PositionReferenceIndicator = ""

		DC3Tag tag (DC3PositionReferenceIndicator_GROUP,
			    DC3PositionReferenceIndicator_ELEMENT);

		DC3LongString *attribute =
			MakeLongStringEmpty(tag);

		list.insert(attribute);
	}
	{
		// Rows
		// Columns

		Uint16 i = VISION_DisplayMatrixSize.toUS();
		{
			DC3Tag tag (DC3Columns_GROUP,
				    DC3Columns_ELEMENT);
			DC3UnsignedShort *attribute =
				new DC3UnsignedShort(tag,2,&i);
			list.insert(attribute);
		}
		{
			DC3Tag tag (DC3Rows_GROUP,
				    DC3Rows_ELEMENT);
			DC3UnsignedShort *attribute =
				new DC3UnsignedShort(tag,2,&i);
			list.insert(attribute);
		}
	}
