.TH DC3INTRO 1 "19 February 1995" "DICOM PS3" "DICOM PS3 - Dicom utility programs"
.SH NAME
dc3intro \- ACR/NEMA DICOM PS3 ... Dicom utility programs
.SH SYNOPSIS
.HP 10
.B dc3cp
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-i " inputtransfersyntax"
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.I outputfilename
.HP 10
.B dc3create
[
.B \-b
]
[
.B \-e
]
<
.I inputfilename
>
.I outputfilename
.HP 10
.B dc3desc
.I inputfilename
.HP 10
.B dc3dump
[
.B \-w
]
[
.B \-b
]
[
.BI \-i " inputtransfersyntax"
]
.I inputfilename
.HP 10
.B dc3iod
[
.BI \-i " inputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.HP 10
.B dc3key
[
.BI \-k " keyword"
] ...
[
.BI \-i " inputtransfersyntax"
]
[
.B \-l
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.HP 10
.B dc3topnm
[
.BI \-i " inputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.I outputfilename
.HP 10
.B dc3toraw
[
.BI \-i " inputtransfersyntax"
]
[
.BI \-o " outputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
[
.B \-c
]
.I inputfilename
.I outputfilename
.HP 10
.B dc3unid
.I inputfilename
.I outputfilename
[
.B dc3cp options
 ... ]
.HP 10
.B dc3value
[
.BI \-k " keyword"
] ...
[
.BI \-i " inputtransfersyntax"
]
[
.B \-l
]
[
.B \-s
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.HP 10
.B dc3xdisp
[
.BI \-i " inputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.HP 10
.B rawtodc
.BI \-w " width"
.BI \-h " height"
.BI \-d " depth"
[
.B \-l|b
]
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-x " key"
]
[
.BI \-r " key" " value"
]
[
.BI \-s " stamp"
]
[
.B \-v
]
[
.I inputfilename
| \- <
.I inputfile
]
.I outputfilename
.SH DESCRIPTION
.LP
This man page briefly describes the utility programs available for manipulating 
.I DICOM
(Digital Imaging Communications in Medicine) version 3 offline files, as described in the standard published by 
.I ACR/NEMA 
(American College of Radiology and National Electrical Manufacturers Association). The utilities copy, dump, and translate to and from primitive file types. The common features and options are described here.
.LP
For more information about each specific utility, see the individual man pages listed under the "See Also" section.
.LP
Described elsewhere are programs for converting from various vendor's proprietary image formats, both to DICOM offline files (see the man page dc3convert.1) as well as primitive file types (see the man page dc3simple.1), utilities for extracting images from various vendor's proprietary archive formats (nine-track tape, etc.) (see the man page dc3archive.1),and various miscellaneous utilities related to manipulation of medical images (see the man page dc3misc.1).
.LP
.B dc3cp
reads the named dicom input file and copies it a dicom output file.
.LP
.B dc3create
creates a dicom 3 or earlier acr/nema file from a description of attributes.
.LP
.B dc3desc
opens the named dicom input file and attempts to identify its transfer syntax, including the presence of a metaheader.
.LP
.B dc3dump
reads the named dicom input file and describes its contents.
.LP
.B dc3iod
reads the named dicom input file and attempts to build DICOM 3 modules, reporting any invalid or missing elements.
.LP
.B dc3key
reads the named dicom input file and extracts attributes by keyword and displays their values (for scripts).
.LP
.B dc3topnm
reads the named dicom input file and extracts the image pixel data to the
specified pnm output file.
.LP
.B dc3toraw
reads the named dicom input file and extracts the image pixel data to the
specified raw output file.
.LP
.B dc3unid
reads the named dicom input file and copies it a dicom output file, replacing identifying information with something innocuous.
.LP
.B dc3value
reads the named dicom input file and extracts attributes by keyword and displays their values (for debugging).
.LP
.B dc3xdisp
reads the named dicom input file and displays its contents on standard
error, using the barest minimum of X Windows features.
.LP
.B rawtodc
reads the named input file or standard in and creates a minimal dicom dataset in the named output file.
.SH OPTIONS
Input and output file names must be specified for most utilities. Redirection from standard input or to standard output is generally not supported. The dump output and verbose output go to standard error.
.LP
Switch options must not be concatenated - they must have their own
leading hyphen. Keyword names are taken from the DICOM Standard data
dictionary, with spaces between words elided.
.LP
For input, if an explicit input transfer syntax is not specified, any valid DICOM 3 Part 10 metaheader present will be used, otherwise an attempt to guess the byte order and value representation will be made (skipping 128 bytes if necessary to allow Siemens SPI files to be read).
.LP
The default output transfer syntax is the Default Little Endian
transfer syntax, which may be overridden as required by specifying the
appropriate UID on the command line. A DICOM 3 Part 10 metaheader will only be written if the -m option is specified. The use of this option is mandatory for
full DICOM 3 compliance, but it is not the default in view of the history of various DICOM implementations and tools.
.LP
Some handy UIDs to know for transfer syntaxes include:
\n 
\n implicit vr little endian   1.2.840.10008.1.2
\n explicit vr little endian   1.2.840.10008.1.2.1
\n explicit vr big    endian   1.2.840.10008.1.2.2
\n 
.LP
Group lengths and length to end are recalculated as necessary, even though no longer required by the standard, to maintain backward compatibility.
.LP
If the -b option is specified, rather than aborting on the first unrecognized attribute, such unrecognized (not in the DICOM Standard or previous standards) attributes are dropped.
.LP
Those private attributes that are known, such as Siemens SPI attributes, are recognized, and used like any defined DICOM attribute. The dataset remains valid DICOM because version 3 is compatible with older ACR/NEMA versions' private group mechanism. Attributes in groups defined by private creators unknown to the program will be treated as unrecognized.
.PP
The basic switches (not all apply to all utilities) are:
.TP
.BI \-d " deletekeyword"
.TP
.BI \-x " deletekeyword"
.LP
.RS
Delete attribute described by "keyword".
.RE
.TP
.BI \-r " replacekeyword values"
.LP
.RS
Replace (or insert if not there) the attribute described by "keyword. If the
attribute has a string value representation, then multiple values separated
by the standard DICOM backslash delimiter should be used. For integer
value representations multiple values separated by any single non-numeric
character will work.
.RE
.TP
.B \-m
.RS
Metaheader flag - write Part 10 style metaheader (mandatory for
full DICOM 3 compliance).
.RE
.TP
.BI \-i " inputtransfersyntax"
.TP
.BI \-o " outputtransfersyntax"
.TP
.BI \-s " datestamp"
.LP
.RS
Use the supplied value rather than the current date and time to create
unique identifiers (UIDs) when needed.
.RE
.TP
.B \-v
.RS
Verbose flag - describes the DICOM tags being read or generated.
.RE
.TP
.B \-w
.RS
Warning flag - be more vocal about dubious attributes.
.RE
.TP
.B \-b
.RS
Bad attribute flag - skip rather than abort on unrecognized attribute.
.RE
.TP
.BI \-w " width"
.TP
.BI \-h " height"
.TP
.BI \-d " depth"
.TP
.B \-l|b
.RS
Byte order flag ... one of l (little) or b (big) endian must be specified if depth is > 8.
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\ 
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3cp(1) ,
.BR dc3create(1) ,
.BR dc3desc(1) ,
.BR dc3dump(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3iod(1) ,
.BR dc3key(1) ,
.BR dc3misc(1) ,
.BR dc3simple(1) ,
.BR dc3topnm(1) ,
.BR dc3toraw(1) ,
.BR dc3unid(1) ,
.BR dc3value(1) ,
.BR dc3xdisp(1)
.BR rawtodc(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
No support for deleting/replacing private groups/attributes.
.LP
Metaheader flag should probably be the default.
.LP
