.TH DC3TOPNM 1 "03 February 1995" "DICOM PS3" "DICOM PS3 - Extract image to pnm file"
.SH NAME
dc3topnm \- ACR/NEMA DICOM PS3 ... Extract image to pnm file
.SH SYNOPSIS
.HP 10
.B dc3topnm
[
.BI \-i " inputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.I outputfilename
.SH DESCRIPTION
.LP
.B dc3topnm
reads the named dicom input file and extracts the image pixel data to the
specified pnm output file. Either 8 or 16 bits per pixel will be written
as determined from the BitsAllocated and BitsStored attributes.
.LP
There is no need for an output transfer
syntax to be specified as the byte order for PGM/PPM files is specified (if
extended raw word format is supported). The verbose option output will 
include such things as are necessary to determine the size of the output file (Rows, Columns, etc.).
.SH OPTIONS
Input and output file names 
.I must
be specified. Redirection from standard input or to standard output are
not supported. The dump output and verbose output go to standard error.
.PP
The basic switches are described in dc3intro(1).
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n % dc3topnm \-v test.dc3 test.pgm
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
Currently only SamplesPerPixel == 1 and PhotometricInterpretation ==
MONOCHROME1 or MONOCHROME2 are supported, ie. only PGM files will
be written, not yet PPM. The data must be stored in the low end of the
word and packed 12 bit data is not yet supported.
.LP
Currently 8 bit data will be written in the normal portable raw PNM
format, and > 8 bit data in the extended PNM format (raw with little-endian words and maxval > 255) ... text format as a compile or run-time
option is not yet supported.
