.TH RAWTODC 1 "03 February 1995" "DICOM PS3" "DICOM PS3 - Raw image to dicom file"
.SH NAME
rawtodc \- ACR/NEMA DICOM PS3 ... Raw image to dicom file
.SH SYNOPSIS
.HP 10
.B rawtodc
.BI \-w " width"
.BI \-h " height"
.BI \-d " depth"
[
.B \-l|b
]
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-x " key"
]
[
.BI \-r " key" " value"
]
[
.BI \-s " stamp"
]
[
.B \-v
]
[
.I inputfilename
| \- <
.I inputfile
]
.I outputfilename
.SH DESCRIPTION
.LP
.B rawtodc
reads the named input file or standard in and creates a minimal dicom dataset in the named output file. The mandatory command line parameters specify the dimensions and depth of the image pixel data and its byte order, and are used to create the appropriate attributes in the output.
.LP
The resulting file does not contain all mandatory dicom modules and attributes. These may be added manually using the command line keyword switches.
.LP
.SH OPTIONS
The output file name 
.I must
be specified. The input may come from a named file or by redirection from standard input. The verbose output goes to standard error.
.PP
The basic switches are described in dc3intro(1). Switches specific to this utility are:
.TP
.BI \-w " width"
.TP
.BI \-h " height"
.TP
.BI \-d " depth"
.TP
.B \-l|b
.RS
Byte order flag ... one of l (little) or b (big) endian must be specified if depth is > 8.
.RE
.TP
.BI \-x " deletekeyword"
.LP
.RS
Delete attribute described by "keyword".
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n 
\n % rawtodc \-w 256 \-h 256 \-d 12 \-l \-m \-v - <test.raw test.dc3
\n
\n (0008,0000) IdentifyingGroupLength       [c]
\n (0008,0001) LengthToEnd                  [20084]
\n (0028,0000) ImagePresentationGroupLength [64]
\n (0028,0002) SamplesPerPixel              [1]
\n (0028,0004) PhotometricInterpretation    <MONOCHROME2> 
\n (0028,0010) Rows                         [100]
\n (0028,0011) Columns                      [100]
\n (0028,0100) BitsAllocated                [c]
\n (0028,0101) BitsStored                   [c]
\n (0028,0102) HighBit                      [b]
\n (0028,0103) PixelRepresentation          [0]
\n (0028,0120) PixelPaddingValue            [0]
\n (7fe0,0000) PixelDataGroupLength         [20008]
\n (7fe0,0010) PixelData                    <20000>  
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
The choice of the "-x" flags to delete attributes is dubious, but the "-d" flag used by other utilities was already in use for depth :(
