static char *CopyrightIdentifier(void) { return "@(#)swapfast.cc 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved."; }

#include <iostream.h>
#include <ctype.h>

#include "GetOpt.h"
#include "MainCmd.h"

int
main(int argc, char *argv[])
{
	CCOMMAND(argc,argv);

	GetOpt getopt(argc,argv,"s");
	int c;
	int err=0;
	while ((c=getopt()) != -1 && !err) {
		switch (c) {
			case '?':
			default:
				err=1;
		}
	}

	if (getopt.optind != argc) {
		cerr << "Trailing garbage after options\n" << flush;
		err=1;
	}

	if (err) {
		cerr << "Usage: " << argv[0] << "\n"
		     << flush;
		return 1;
	}

	// default for some environments is unbuffered which is slow++

	const unsigned bufsize=16384;
	streambuf *in  = cin.rdbuf();
	streambuf *out = cout.rdbuf();
	static char inbuf[bufsize];
	static char outbuf[bufsize];
	in->setbuf(inbuf,sizeof(inbuf));
	out->setbuf(outbuf,sizeof(outbuf));

	static char buf[bufsize+1];
	unsigned n;
	while (n=in->sgetn(buf,bufsize)) {
		if (n%2) {
			cerr << "Oops ... not even length ... failed\n"
			     << flush;
			return 1;
		}
		char *ptr=buf+n;
		while (ptr > buf) { *ptr=*(ptr-2); ptr-=2; }
		out->sputn(buf+1,n);
	}

	if (!cin.good()) {
		cerr << "Read error\n" << flush;
		return 1;
	}
	if (!cout.good()) {
		cerr << "Write error\n" << flush;
		return 1;
	}

	return 0;
}

