# Conditions to detect Composite IOD presence ...

Condition="CRImageInstance"
	Element="Modality"		StringValue="CR"
	Element="SOPClassUID"		StringConstant="ComputedRadiographyImageStorageSOPClass"
ConditionEnd

Condition="CTImageInstance"
	Element="Modality"		StringValue="CT"
	Element="SOPClassUID"		StringConstant="CTImageStorageSOPClass"
ConditionEnd

Condition="MRImageInstance"
	Element="Modality"		StringValue="MR"
	Element="SOPClassUID"		StringConstant="MRImageStorageSOPClass"
ConditionEnd

Condition="NMImageInstance"
	Element="Modality"		StringValue="NM"
	Element="SOPClassUID"		StringConstant="NuclearMedicineImageStorageSOPClass"
	Element="ImageNumber"		AndElementPresent=""
ConditionEnd

Condition="NMOverlayInstance"
	Element="Modality"		StringValue="NM"
	Element="SOPClassUID"		StringConstant="NuclearMedicineImageStorageSOPClass"
	Element="OverlayNumber"		AndElementPresent=""
ConditionEnd

Condition="NMCurveInstance"
	Element="Modality"		StringValue="NM"
	Element="SOPClassUID"		StringConstant="NuclearMedicineImageStorageSOPClass"
	Element="CurveNumber"		AndElementPresent=""
ConditionEnd

Condition="USImageInstance"
	Element="Modality"		StringValue="US"
	Element="SOPClassUID"		StringConstant="UltrasoundImageStorageSOPClass"
	Element="ImageNumber"		AndElementPresent=""
ConditionEnd

Condition="USCurveInstance"
	Element="Modality"		StringValue="US"
	Element="SOPClassUID"		StringConstant="UltrasoundImageStorageSOPClass"
	Element="CurveNumber"		AndElementPresent=""
ConditionEnd

Condition="USMultiFrameImageInstance"
	Element="SOPClassUID"		StringConstant="UltrasoundMultiframeImageStorageSOPClass"
	Element="ImageNumber"		AndElementPresent=""
ConditionEnd

Condition="USMultiFrameCurveInstance"
	Element="SOPClassUID"		StringConstant="UltrasoundMultiframeImageStorageSOPClass"
	Element="CurveNumber"		AndElementPresent=""
ConditionEnd

Condition="SCImageInstance"
	Element="Modality"		StringValue="SC"
	Element="SOPClassUID"		StringConstant="SecondaryCaptureImageStorageSOPClass"
ConditionEnd

Condition="StandaloneOverlayInstance"
	Element="SOPClassUID"		StringConstant="StandaloneOverlayStorageSOPClass"
ConditionEnd

Condition="StandaloneCurveInstance"
	Element="SOPClassUID"		StringConstant="StandaloneCurveStorageSOPClass"
ConditionEnd

Condition="StandaloneModalityLUTInstance"
	Element="SOPClassUID"		StringConstant="StandaloneModalityLUTStorageSOPClass"
ConditionEnd

Condition="StandaloneVOILUTInstance"
	Element="SOPClassUID"		StringConstant="StandaloneVOILUTStorageSOPClass"
ConditionEnd

# Conditions for inclusion of Modules with Usage "C" in Composite IODs  ...

# General principle is that if any type 1 or 2 required attributes are
# present then the module is needed

Condition="NeedModuleContrastBolus"
	Element="ContrastBolusAgent"		ElementPresent=""
ConditionEnd

Condition="NeedModuleCine"
	Element="FrameTime"			ElementPresent=""
	Element="FrameTimeVector"		ElementPresent=""
ConditionEnd

Condition="NeedModuleMultiFrame"
	Element="FrameIncrementPointer"		ElementPresent=""
	Element="NumberOfFrames"		ElementPresent=""
ConditionEnd

Condition="NeedModuleNMMultiGatedAcquisitionImage"
	Element="FrameTime"			ElementPresent=""
ConditionEnd

Condition="NeedModuleNMSPECTAcquisitionImage"
	Element="AngularStep"			ElementPresent=""
ConditionEnd

Condition="NeedModuleUSFrameOfReference"
	Element="RegionLocationMinX0"		ElementPresent=""
	Element="RegionLocationMinY0"		ElementPresent=""
	Element="RegionLocationMaxX1"		ElementPresent=""
	Element="RegionLocationMaxY1"		ElementPresent=""
	Element="PhysicalUnitsXDirection"	ElementPresent=""
	Element="PhysicalUnitsYDirection"	ElementPresent=""
	Element="PhysicalDeltaX"		ElementPresent=""
	Element="PhysicalDeltaY"		ElementPresent=""
ConditionEnd

Condition="NeedModuleOverlayPlane"
	# any element in this repeating group will do
	Element="OverlayRows"			GroupPresent="0xff00"
ConditionEnd

Condition="NeedModuleCurve"
	# shares repeating group with audio so check specific elements
	Element="CurveDimensions"		ElementPresent="0xff00"
	Element="NumberOfPoints"		ElementPresent="0xff00"
	Element="TypeOfData"			ElementPresent="0xff00"
	Element="DataValueRepresentation"	ElementPresent="0xff00"
	Element="CurveData"			ElementPresent="0xff00"
ConditionEnd

Condition="NeedModuleAudio"
	# shares repeating group with curve so check specific elements
	Element="AudioType"			ElementPresent="0xff00"
	Element="AudioSampleFormat"		ElementPresent="0xff00"
	Element="NumberOfChannels"		ElementPresent="0xff00"
	Element="NumberOfSamples"		ElementPresent="0xff00"
	Element="SampleRate"			ElementPresent="0xff00"
	Element="TotalTime"			ElementPresent="0xff00"
	Element="AudioSampleData"		ElementPresent="0xff00"
ConditionEnd

Condition="NeedModuleModalityLUT"
	Element="RescaleIntercept"		ElementPresent=""
	# should add ModalityLUTSequence when sequences implemented
ConditionEnd

Condition="NeedModuleVOILUT"
	Element="WindowCenter"			ElementPresent=""
	# should check PhotometricInterpretation is monochrome
	# should add VOILUTSequence when sequences implemented
ConditionEnd

Condition="NeedModuleFrameOfReference"
	Element="FrameOfReferenceUID"		ElementPresent=""
	Element="PositionReferenceIndicator"	ElementPresent=""
ConditionEnd

Condition="NeedModuleImagePlane"
	Element="PixelSpacing"			ElementPresent=""
	Element="ImageOrientationPatient"	ElementPresent=""
	Element="ImagePositionPatient"		ElementPresent=""
ConditionEnd

Condition="NeedModuleMultiFrameOverlay"
	Element="OverlayNumberOfFrames"		ElementPresent=""
ConditionEnd

Condition="NeedModuleUSRegionCalibration"
	# should add SequenceOfUltrasoundRegions when sequences implemented
ConditionEnd

Condition="NeedModuleGeneralEquipment"
	Element="Manufacturer"			ElementPresent=""
ConditionEnd

# Conditions for inclusion of type 1C and 2C Elements in Modules  ...

Condition="SamplesPerPixelGreaterThanOne"
	Element="SamplesPerPixel"		BinaryValue="> 1"
ConditionEnd

Condition="PhotometricInterpretationNeedsPalette"
	Element="PhotometricInterpretation"	StringValue="PALETTE COLOR"
	Element="PhotometricInterpretation"	StringValue="ARGB"
ConditionEnd

Condition="ModalityIsCTOrMR"
	Element="Modality"			StringValue="CT"
	Element="Modality"			StringValue="MR"
ConditionEnd

Condition="ImagePlaneModuleNotRequired"
	# probably not strictly correct, esp. for US multiframe ...
	Element="Modality"			StringValue="CR"
	Element="Modality"			StringValue="NM"
	Element="Modality"			StringValue="US"
	Element="Modality"			StringValue="SC"
	# don't know what to do about standalone IODs
ConditionEnd

Condition="MRIsNotEchoPlanarNotSegmentedKSpace"
	# don't have facility to check multiple values :( so not quite right
	Element="ScanningSequence"		StringValue="SE"
	Element="ScanningSequence"		StringValue="IR"
	Element="ScanningSequence"		StringValue="GR"
	Element="ScanningSequence"		StringValue="RM"
ConditionEnd

Condition="MRIsInversionRecovery"
	# don't have facility to check multiple values :( so not quite right
	Element="ScanningSequence"		StringValue="IR"
ConditionEnd

Condition="MRIsCardiacOrPulseGated"
	# don't have facility to check multiple values :( so not quite right
	Element="ScanOptions"			StringValue="CG"
	Element="ScanOptions"			StringValue="PPG"
ConditionEnd

Condition="NMIsWholeBody"
	Element="NuclearMedicineSeriesType"	StringValue="WHOLE BODY"
ConditionEnd

Condition="CurveDataDescriptorPresent"
	Element="CurveDataDescriptor"		ElementPresent="0xff00"
ConditionEnd

Condition="ModalityLUTSequenceNotPresent"
	Element="ModalityLUTSequence"		NotElementPresent=""
ConditionEnd

Condition="RescaleInterceptPresent"
	Element="RescaleIntercept"		ElementPresent=""
ConditionEnd

Condition="WindowCenterPresent"
	Element="WindowCenter"			ElementPresent=""
ConditionEnd

