Module="PatientRelationship"

	Sequence="ReferencedStudySequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedVisitSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedPatientAliasSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="PatientIdentification"

	Name="PatientName"
	Name="PatientID"
	Name="IssuerOfPatientID"
	Name="OtherPatientID"
	Name="OtherPatientName"
	Name="PatientBirthName"
	Name="PatientMotherBirthName"
	Name="MedicalRecordLocator"

ModuleEnd

Module="PatientDemographic"

	Name="PatientBirthDate"
	Name="PatientBirthTime"
	Name="PatientSex"					StringEnumValues="Sex"
	Sequence="PatientInsurancePlanCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="DiagnosticCodingSchemes"
		SName="CodeMeaning"
	SequenceEnd
	Name="PatientSize"
	Name="PatientWeight"
	Name="PatientAddress"
	Name="MilitaryRank"
	Name="BranchOfService"
	Name="CountryOfResidence"
	Name="RegionOfResidence"
	Name="PatientTelephoneNumber"
	Name="EthnicGroup"
	Name="PatientReligiousPreference"
	Name="PatientComments"

ModuleEnd

Module="PatientMedical"

	Name="MedicalAlerts"
	Name="ContrastAllergies"
	Name="SmokingStatus"					StringEnumValues="SmokingStatus"
	Name="AdditionalPatientHistory"
	Name="PregnancyStatus"					BinaryEnumValues="PregnancyStatus"
	Name="LastMenstrualDate"
	Name="SpecialNeeds"
	Name="PatientState"

ModuleEnd

Module="VisitRelationship"

	Sequence="ReferencedStudySequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedPatientSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="VisitIdentification"

	Name="InstitutionName"
	Name="InstitutionAddress"
	Sequence="InstitutionCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="DiagnosticCodingSchemes"
		SName="CodeMeaning"
	SequenceEnd
	Name="AdmissionID"
	Name="IssuerOfAdmissionID"

ModuleEnd

Module="VisitStatus"

	Name="VisitStatusID"					StringDefinedTerms="VisitStatusID"
	Name="CurrentPatientLocation"
	Name="PatientInstitutionResidence"
	Name="VisitComments"

ModuleEnd

Module="VisitAdmission"

	Name="ReferringPhysicianName"
	Name="ReferringPhysicianAddress"
	Name="ReferringPhysicianTelephoneNumber"
	Name="AdmittingDiagnosisDescription"
	Sequence="AdmittingDiagnosisCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="DiagnosticCodingSchemes"
		SName="CodeMeaning"
	SequenceEnd
	Name="RouteOfAdmissions"
	Name="AdmittingDate"
	Name="AdmittingTime"

ModuleEnd

Module="VisitDischarge"

	Name="DischargeDate"
	Name="DischargeTime"
	Name="DischargeDiagnosisDescription"
	Sequence="DischargeDiagnosisCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="DiagnosticCodingSchemes"
		SName="CodeMeaning"
	SequenceEnd

ModuleEnd

Module="VisitScheduling"

	Name="ScheduledAdmissionDate"
	Name="ScheduledAdmissionTime"
	Name="ScheduledDischargeDate"
	Name="ScheduledDischargeTime"
	Name="ScheduledPatientInstitutionResidence"

ModuleEnd

Module="StudyRelationship"

	Sequence="ReferencedVisitSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedPatientSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedResultsSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedStudyComponentSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Name="StudyInstanceUID"
	Name="AccessionNumber"

ModuleEnd

Module="StudyIdentification"

	Name="StudyID"
	Name="StudyIDIssuer"
	Name="OtherStudyNumbers"

ModuleEnd

Module="StudyClassification"

	Name="StudyStatusID"					StringEnumValues="StudyStatusID"
	Name="StudyPriorityID"					StringEnumValues="Priority"
	Name="StudyComments"

ModuleEnd

Module="StudyScheduling"

	Name="ScheduledStudyStartDate"
	Name="ScheduledStudyStartTime"
	Name="ScheduledStudyStopDate"
	Name="ScheduledStudyStopTime"
	Name="ScheduledStudyLocation"
	Name="ScheduledStudyLocationAETitle"
	Name="ReasonForStudy"
	Name="RequestingPhysician"
	Name="RequestingService"
	Name="RequestedProcedureDescription"
	Sequence="RequestedProcedureCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="ProcedureCodeScheme"
		SName="CodeMeaning"
	SequenceEnd
	Name="RequestedContrastAgent"

ModuleEnd

Module="StudyAcquisition"

	Name="StudyArrivalDate"
	Name="StudyArrivalTime"
	Name="StudyDate"
	Name="StudyTime"
	Name="StudyCompletionDate"
	Name="StudyCompletionTime"
	Name="StudyVerifiedDate"
	Name="StudyVerifiedTime"
	Name="SeriesInStudy"
	Name="AcquisitionsInStudy"

ModuleEnd

Module="StudyRead"

	Name="PhysicianReadingStudy"
	Name="StudyReadDate"
	Name="StudyReadTime"

ModuleEnd

Module="StudyComponent"

	Name="StudyID"
	Name="StudyInstanceUID"
	Sequence="ReferencedSeriesSequence"
		SName="SeriesDate"
		SName="SeriesTime"
		SName="SeriesInstanceUID"
		SName="RetrieveAETitle"
		SName="StorageMediaFileSetID"
		SName="StorageMediaFileSetUID"
		Sequence="ReferencedImageSequence"
			SSName="ReferencedSOPClassUID"
			SSName="ReferencedSOPInstanceUID"
			SSName="RetrieveAETitle"
			SSName="StorageMediaFileSetID"
			SSName="StorageMediaFileSetUID"
		SequenceEnd
	SequenceEnd

ModuleEnd

Module="StudyComponentRelationship"

	Sequence="ReferencedStudySequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="StudyComponentAcquisition"

	Name="Modality"						StringDefinedTerms="Modality"
	Name="StudyDescription"
	Sequence="ProcedureCodeSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="ProcedureCodeScheme"
		SName="CodeMeaning"
	SequenceEnd
	Name="PerformingPhysicianName"
	Name="StudyComponentStatusID"				StringEnumValues="StudyComponentStatusID"

ModuleEnd

Module="ResultsRelationship"

	Sequence="ReferencedStudySequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedInterpretationSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="ResultsIdentification"

	Name="ResultsID"
	Name="ResultsIDIssuer"

ModuleEnd

Module="ResultsImpression"

	Name="Impressions"
	Name="ResultsComments"

ModuleEnd

Module="InterpretationRelationship"

	Sequence="ReferencedResultsSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="InterpretationIdentification"

	Name="InterpretationID"
	Name="InterpretationIDIssuer"

ModuleEnd

Module="InterpretationState"

	Name="InterpretationTypeID"				StringDefinedTerms="InterpretationTypeID"
	Name="InterpretationStatusID"				StringEnumValues="InterpretationStatusID"

ModuleEnd

Module="InterpretationRecording"

	Name="InterpretationRecordedDate"
	Name="InterpretationRecordedTime"
	Name="InterpretationRecorder"
	Name="ReferenceToRecordedSound"

ModuleEnd

Module="InterpretationTranscription"

	Name="InterpretationTranscriptionDate"
	Name="InterpretationTranscriptionTime"
	Name="InterpretationTranscriber"
	Name="InterpretationText"
	Name="InterpretationAuthor"

ModuleEnd

Module="InterpretationApproval"

	Sequence="InterpretationApproverSequence"
		SName="InterpretationApprovalDate"
		SName="InterpretationApprovalTime"
		SName="PhysicianApprovingInterpretation"
	SequenceEnd
	Name="InterpretationDiagnosisDescription"
	Sequence="InterpretationDiagnosisCodesSequence"
		SName="CodeValue"
		SName="CodingSchemeDesignator"			StringDefinedTerms="DiagnosticCodingSchemes"
		SName="CodeMeaning"
	SequenceEnd
	Sequence="ResultsDistributionListSequence"
		SName="DistributionName"
		SName="DistributionAddress"
	SequenceEnd

ModuleEnd

Module="Patient"

	Name="PatientName"				Type="2"
	Name="PatientID"				Type="2"
	Name="PatientBirthDate"				Type="2"
	Name="PatientSex"				Type="2"	StringEnumValues="Sex"
	Sequence="ReferencedPatientSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="PatientBirthTime"				Type="3"
	Name="OtherPatientID"				Type="3"
	Name="OtherPatientName"				Type="3"
	Name="EthnicGroup"				Type="3"
	Name="PatientComments"				Type="3"

ModuleEnd

Module="GeneralStudy"

	Name="StudyInstanceUID"				Type="1"
	Name="StudyDate"				Type="2"
	Name="StudyTime"				Type="2"
	Name="ReferringPhysicianName"			Type="2"
	Name="StudyID"					Type="2"
	Name="AccessionNumber"				Type="2"
	Name="StudyDescription"				Type="3"
	Name="PhysicianReadingStudy"			Type="3"
	Sequence="ReferencedStudySequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd

ModuleEnd

Module="PatientStudy"

	Name="AdmittingDiagnosisDescription"		Type="3"
	Name="PatientAge"				Type="3"
	Name="PatientSize"				Type="3"
	Name="PatientWeight"				Type="3"
	Name="Occupation"				Type="3"
	Name="AdditionalPatientHistory"			Type="3"

ModuleEnd

Module="GeneralSeries"

	Name="Modality"					Type="1"	StringDefinedTerms="Modality"
	Name="SeriesInstanceUID"			Type="1"
	Name="SeriesNumber"				Type="2"
	Name="Laterality"				Type="2C"	StringEnumValues="Laterality"	Condition="Never"
	Name="SeriesDate"				Type="3"
	Name="SeriesTime"				Type="3"
	Name="PerformingPhysicianName"			Type="3"
	Name="ProtocolName"				Type="3"
	Name="SeriesDescription"			Type="3"
	Name="OperatorName"				Type="3"
	Sequence="ReferencedStudyComponentSequence"	Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="BodyPartExamined"				Type="3"	StringDefinedTerms="BodyPartExamined"
	Name="PatientPosition"				Type="2C"	StringDefinedTerms="PatientPosition"	Condition="ModalityIsCTOrMR"
	Name="SmallestPixelValueInSeries"		Type="3"
	Name="LargestPixelValueInSeries"		Type="3"

ModuleEnd

Module="FrameOfReference"

	Name="FrameOfReferenceUID"			Type="1"
	Name="PositionReferenceIndicator"		Type="2"

ModuleEnd

Module="GeneralEquipment"

	Name="Manufacturer"				Type="2"
	Name="InstitutionName"				Type="3"
	Name="InstitutionAddress"			Type="3"
	Name="StationName"				Type="3"
	Name="InstitutionalDepartmentName"		Type="3"
	Name="ManufacturerModelName"			Type="3"
	Name="DeviceSerialNumber"			Type="3"
	Name="SoftwareVersion"				Type="3"
	Name="SpatialResolution"			Type="3"
	Name="DateOfLastCalibration"			Type="3"
	Name="TimeOfLastCalibration"			Type="3"
	Name="PixelPaddingValue"			Type="3"

ModuleEnd

Module="GeneralImage"

	Name="ImageNumber"				Type="2"
	Name="PatientOrientation"			Type="2C"	Condition="ImagePlaneModuleNotRequired"
	Name="ImageDate"				Type="2C"	Condition="Always"	# needs work
	Name="ImageTime"				Type="2C"	Condition="Always"	# needs work
	Name="ImageType"				Type="3"	StringEnumValues(1)="ImageType1" StringEnumValues(2)="ImageType2"
	Name="AcquisitionNumber"			Type="3"
	Name="AcquisitionDate"				Type="3"
	Name="AcquisitionTime"				Type="3"
	Sequence="ReferencedImageSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="DerivationDescription"			Type="3"
	Sequence="SourceImageSequence"			Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="ImagesInAcquisition"			Type="3"
	Name="ImageComments"				Type="3"

ModuleEnd

Module="ImagePlane"

	Name="PixelSpacing"				Type="1"
	Name="ImageOrientationPatient"			Type="1"
	Name="ImagePositionPatient"			Type="1"
	Name="SliceThickness"				Type="2"
	Name="SliceLocation"				Type="3"

ModuleEnd

Module="ImagePixel"

	Name="SamplesPerPixel"				Type="1"
	Name="PhotometricInterpretation"		Type="1"	StringDefinedTerms="PhotometricInterpretation"
	Name="Rows"					Type="1"
	Name="Columns"					Type="1"
	Name="BitsAllocated"				Type="1"
	Name="BitsStored"				Type="1"
	Name="HighBit"					Type="1"
	Name="PixelRepresentation"			Type="1"	BinaryEnumValues="PixelRepresentation"
	Name="PixelData"				Type="1"
	Name="PlanarConfiguration"			Type="1C"	BinaryEnumValues="PlanarConfiguration"	Condition="SamplesPerPixelGreaterThanOne"
	Name="PixelAspectRatio"				Type="1C"	Condition="Never"	# needs work
	Name="SmallestImagePixelValue"			Type="3"
	Name="LargestImagePixelValue"			Type="3"
	Name="RedPaletteColorLookupTableDescriptor"	Type="1C"	Condition="PhotometricInterpretationNeedsPalette"
	Name="GreenPaletteColorLookupTableDescriptor"	Type="1C"	Condition="PhotometricInterpretationNeedsPalette"
	Name="BluePaletteColorLookupTableDescriptor"	Type="1C"	Condition="PhotometricInterpretationNeedsPalette"
	Name="RedPaletteColorLookupTableData"		Type="1C"	Condition="PhotometricInterpretationNeedsPalette"
	Name="GreenPaletteColorLookupTableData"		Type="1C"	Condition="PhotometricInterpretationNeedsPalette"
	Name="BluePaletteColorLookupTableData"		Type="1C"	Condition="PhotometricInterpretationNeedsPalette"

ModuleEnd

Module="ContrastBolus"

	Name="ContrastBolusAgent"			Type="2"
	Name="ContrastBolusRoute"			Type="3"
	Name="ContrastBolusVolume"			Type="3"
	Name="ContrastBolusStartTime"			Type="3"
	Name="ContrastBolusStopTime"			Type="3"
	Name="ContrastBolusTotalDose"			Type="3"

ModuleEnd

Module="Cine"

	Name="FrameTime"				Type="1C"	Condition="Never"	# needs work
	Name="FrameTimeVector"				Type="1C"	Condition="Never"	# needs work
	Name="StartTrim"				Type="3"
	Name="StopTrim"					Type="3"
	Name="RecommendedDisplayFrameRate"		Type="3"
	Name="CineRate"					Type="3"
	Name="FrameDelay"				Type="3"
	Name="EffectiveSeriesDuration"			Type="3"
	Name="ActualFrameDuration"			Type="3"

ModuleEnd

Module="MultiFrame"

	Name="NumberOfFrames"				Type="1"
	Name="FrameIncrementPointer"			Type="1"

ModuleEnd

Module="PatientSummary"

	Name="PatientName"				Type="2"
	Name="PatientID"				Type="2"

ModuleEnd

Module="StudyContent"

	Name="StudyID"						Type="2"
	Name="StudyInstanceUID"					Type="1"
	Sequence="ReferencedSeriesSequence"			Type="1"
		SName="SeriesInstanceUID"			Type="1"
		SName="RetrieveAETitle"				Type="2C"
		SName="StorageMediaFileSetID"			Type="2C"
		SName="StorageMediaFileSetUID"			Type="2C"
		Sequence="ReferencedImageSequence"		Type="1"
			SSName="ReferencedSOPClassUID"		Type="2"
			SSName="ReferenceSOPInstanceUID"	Type="2"
			SSName="RetrieveAETitle"		Type="2C"
			SSName="StorageMediaFileSetID"		Type="2C"
			SSName="StorageMediaFileSetUID"		Type="2C"
		SequenceEnd
	SequenceEnd

ModuleEnd

Module="CRSeries"

	Name="BodyPartExamined"				Type="2"	StringDefinedTerms="BodyPartExamined"
	Name="ViewPosition"				Type="2"	StringDefinedTerms="ViewPosition"
	Name="FilterType"				Type="3"
	Name="CollimatorGridName"			Type="3"
	Name="FocalSpot"				Type="3"
	Name="PlateType"				Type="3"
	Name="PhosphorType"				Type="3"

ModuleEnd

Module="CRImage"

	Name="KVP"					Type="3"
	Name="PlateID"					Type="3"
	Name="DistanceSourceToDetector"			Type="3"
	Name="DistanceSourceToPatient"			Type="3"
	Name="ExposureTime"				Type="3"
	Name="XrayTubeCurrent"				Type="3"
	Name="Exposure"					Type="3"
	Name="GeneratorPower"				Type="3"
	Name="AcquisitionDeviceProcessingDescription"	Type="3"
	Name="AcquisitionDeviceProcessingCode"		Type="3"
	Name="CassetteOrientation"			Type="3"	StringEnumValues="Orientation"
	Name="CassetteSize"				Type="3"	StringDefinedTerms="CassetteSize"
	Name="ExposuresOnPlate"				Type="3"
	Name="RelativeXrayExposure"			Type="3"
	Name="Sensitivity"				Type="3"

ModuleEnd

Module="CTImage"

	Name="ImageType"				Type="1"	StringDefinedTerms(3)="CTImageType3"
	Name="SamplesPerPixel"				Type="1"	BinaryEnumValues="SamplesPerPixelIsOne"
	Name="PhotometricInterpretation"		Type="1"	StringEnumValues="PhotometricInterpretationMonochrome"
	Name="BitsAllocated"				Type="1"	BinaryEnumValues="BitsAre16"
	Name="BitsStored"				Type="1"	BinaryEnumValues="BitsAre12Or16"
	Name="HighBit"					Type="1"	BinaryEnumValues="BitsAre11Or15"
	Name="RescaleIntercept"				Type="1"
	Name="RescaleSlope"				Type="1"
	Name="KVP"					Type="2"
	Name="AcquisitionNumber"			Type="2"
	Name="ScanOptions"				Type="3"
	Name="DataCollectionDiameter"			Type="3"
	Name="DistanceSourceToDetector"			Type="3"
	Name="DistanceSourceToPatient"			Type="3"
	Name="GantryDetectorTilt"			Type="3"
	Name="TableHeight"				Type="3"
	Name="RotationDirection"			Type="3"	StringEnumValues="RotationDirection"
	Name="ExposureTime"				Type="3"
	Name="XrayTubeCurrent"				Type="3"
	Name="Exposure"					Type="3"
	Name="FilterType"				Type="3"
	Name="GeneratorPower"				Type="3"
	Name="FocalSpot"				Type="3"
	Name="ConvolutionKernel"			Type="3"

ModuleEnd

Module="MRImage"

	Name="ImageType"				Type="1"	StringDefinedTerms(3)="MRImageType3"
	Name="SamplesPerPixel"				Type="1"	BinaryEnumValues="SamplesPerPixelIsOne"
	Name="PhotometricInterpretation"		Type="1"	StringEnumValues="PhotometricInterpretationMonochrome"
	Name="BitsAllocated"				Type="1"	BinaryEnumValues="BitsAre16"
	Name="ScanningSequence"				Type="1"	StringEnumValues="ScanningSequence"
	Name="SequenceVariant"				Type="1"	StringDefinedTerms="SequenceVariant"
	Name="ScanOptions"				Type="2"	StringDefinedTerms="ScanOptions"
	Name="MRAcquisitionType"			Type="2"	StringEnumValues="MRAcquisitionType"
	Name="RepetitionTime"				Type="2C"	Condition="MRIsNotEchoPlanarNotSegmentedKSpace"
	Name="EchoTime"					Type="2"
	Name="EchoTrainLength"				Type="2"
	Name="InversionTime"				Type="2C"	Condition="MRIsInversionRecovery"
	Name="TriggerTime"				Type="2C"	Condition="MRIsCardiacOrPulseGated"
	Name="SequenceName"				Type="3"
	Name="AngioFlag"				Type="3"	StringEnumValues="AngioFlag"
	Name="NumberOfAverages"				Type="3"
	Name="ImagingFrequency"				Type="3"
	Name="ImagedNucleus"				Type="3"
	Name="EchoNumber"				Type="3"
	Name="MagneticFieldStrength"			Type="3"
	Name="SpacingBetweenSlices"			Type="3"
	Name="NumberOfPhaseEncodingSteps"		Type="3"
	Name="PercentSampling"				Type="3"
	Name="PercentPhaseFieldOfView"			Type="3"
	Name="PixelBandwidth"				Type="3"
	Name="NominalInterval"				Type="3"
	Name="BeatRejectionFlag"			Type="3"	StringEnumValues="YesNoLetter"
	Name="LowRRValue"				Type="3"
	Name="HighRRValue"				Type="3"
	Name="IntervalsAcquired"			Type="3"
	Name="IntervalsRejected"			Type="3"
	Name="PVCRejection"				Type="3"
	Name="SkipBeats"				Type="3"
	Name="HeartRate"				Type="3"
	Name="CardiacNumberOfImages"			Type="3"
	Name="TriggerWindow"				Type="3"
	Name="ReconstructionDiameter"			Type="3"
	Name="ReceivingCoil"				Type="3"
	Name="TransmittingCoil"				Type="3"
	Name="AcquisitionMatrix"			Type="3"
	Name="PhaseEncodingDirection"			Type="3"	StringEnumValues="PhaseEncodingDirection"
	Name="FlipAngle"				Type="3"
	Name="SAR"					Type="3"
	Name="VariableFlipAngleFlag"			Type="3"	StringEnumValues="YesNoLetter"
	Name="dBdt"					Type="3"
	Name="TemporalPositionIdentifier"		Type="3"
	Name="NumberOfTemporalPositions"		Type="3"
	Name="TemporalResolution"			Type="3"

ModuleEnd

Module="NMSeries"

	Name="Radionuclide"				Type="2"
	Name="NuclearMedicineSeriesType"		Type="2"	StringDefinedTerms="NuclearMedicineSeriesType"
	Name="ScanVelocity"				Type="2C"	Condition="NMIsWholeBody"
	Name="WholeBodyTechnique"			Type="2C"	StringEnumValues="WholeBodyTechnique"	Condition="NMIsWholeBody"
	Name="ScanLength"				Type="2C"	Condition="NMIsWholeBody"
	Name="Radiopharmaceutical"			Type="3"
	Name="EnergyWindowCenterline"			Type="3"
	Name="EnergyWindowTotalWidth"			Type="3"
	Name="InterventionalDrugName"			Type="3"
	Name="InterventionalDrugStartTime"		Type="3"
	Name="EffectiveSeriesDuration"			Type="3"
	Name="SyringeCounts"				Type="3"
	Name="TriggerSourceOrType"			Type="3"
	Name="RadionuclideRoute"			Type="3"
	Name="RadionuclideVolume"			Type="3"
	Name="RadionuclideStartTime"			Type="3"
	Name="RadionuclideStopTime"			Type="3"
	Name="RadionuclideTotalDose"			Type="3"
	Name="GantryDetectorTilt"			Type="3"
	Name="IsotopeNumber"				Type="3"

ModuleEnd

Module="NMEquipment"

	Name="CenterOfRotationOffset"			Type="3"
	Name="FieldOfViewShape"				Type="3"	StringDefinedTerms="FieldOfViewShape"
	Name="FieldOfViewDimension"			Type="3"
	Name="CollimatorGridName"			Type="3"
	Name="CollimatorType"				Type="3"	StringDefinedTerms="CollimatorType"
	Name="FocalDistance"				Type="3"
	Name="XFocusCenter"				Type="3"
	Name="YFocusCenter"				Type="3"

ModuleEnd

Module="NMImage"

	Name="FrameIncrementPointer"			Type="1C"	Condition="Never"	# needs work
	Name="ZoomFactor"				Type="2"
	Name="CountsAccumulated"			Type="2"
	Sequence="ReferencedOverlaySequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Sequence="ReferencedCurveSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="AcquisitionTerminationCondition"		Type="3"	StringDefinedTerms="AcquisitionTerminationCondition"
	Name="ReconstructionDiameter"			Type="3"
	Name="DistanceSourceToDetector"			Type="3"
	Name="TableHeight"				Type="3"
	Name="TableTraverse"				Type="3"
	Name="AngularPosition"				Type="3"
	Name="RadialPosition"				Type="3"
	Name="ConvolutionKernel"			Type="3"
	Name="ActualFrameDuration"			Type="3"
	Name="CountRate"				Type="3"
	Name="PreprocessingFunction"			Type="3"
	Name="PostprocessingFunction"			Type="3"
	Name="PhaseNumber"				Type="3"
	Name="IntervalNumber"				Type="3"
	Name="TimeSlotNumber"				Type="3"
	Name="AngleNumber"				Type="3"
	Name="ZoomCenter"				Type="3"
	Name="CorrectedImage"				Type="3"	StringDefinedTerms="CorrectedImage"

ModuleEnd

Module="NMSPECTAcquisitionImage"

	Name="FrameIncrementPointer"			Type="1"
	Name="AngularStep"				Type="1"
	Name="ZoomFactor"				Type="2"
	Name="ScanArc"					Type="2C"	Condition="Never"	# "if the image is tomographic" ... needs work
	Name="ReconstructionDiameter"			Type="3"
	Name="DistanceSourceToDetector"			Type="3"
	Name="TableHeight"				Type="3"
	Name="TableTraverse"				Type="3"
	Name="RotationDirection"			Type="3"	StringEnumValues="RotationDirection"
	Name="AngularPosition"				Type="3"
	Name="RadialPosition"				Type="3"
	Name="RotationOffset"				Type="3"
	Name="AngleNumber"				Type="3"
	Name="ZoomCenter"				Type="3"

ModuleEnd

Module="NMMultiGatedAcquisitionImage"

	Name="FrameIncrementPointer"			Type="1"
	Name="TriggerSourceOrType"			Type="2"
	Name="FrameTime"				Type="2"
	Name="TriggerTime"				Type="3"
	Name="NominalInterval"				Type="3"
	Name="FramingType"				Type="3"
	Name="BeatRejectionFlag"			Type="3"	StringEnumValues="YesNoLetter"
	Name="LowRRValue"				Type="3"
	Name="HighRRValue"				Type="3"
	Name="IntervalsAcquired"			Type="3"
	Name="IntervalsRejected"			Type="3"
	Name="PVCRejection"				Type="3"
	Name="SkipBeats"				Type="3"
	Name="HeartRate"				Type="3"
	Name="CardiacNumberOfImages"			Type="3"

ModuleEnd

Module="USFrameOfReference"

	Name="RegionLocationMinX0"			Type="1"
	Name="RegionLocationMinY0"			Type="1"
	Name="RegionLocationMaxX1"			Type="1"
	Name="RegionLocationMaxY1"			Type="1"
	Name="PhysicalUnitsXDirection"			Type="1"
	Name="PhysicalUnitsYDirection"			Type="1"
	Name="PhysicalDeltaX"				Type="1"
	Name="PhysicalDeltaY"				Type="1"
	Name="ReferencePixelX0"				Type="3"
	Name="ReferencePixelY0"				Type="3"
	Name="ReferencePixelPhysicalValueX"		Type="3"
	Name="ReferencePixelPhysicalValueY"		Type="3"

ModuleEnd

Module="USRegionCalibration"

	Sequence="SequenceOfUltrasound Regions"		Type="1"
		SName="RegionLocationMinX0"		Type="1"
		SName="RegionLocationMinY0"		Type="1"
		SName="RegionLocationMaxX1"		Type="1"
		SName="RegionLocationMaxY1"		Type="1"
		SName="PhysicalUnitsXDirection"		Type="1"
		SName="PhysicalUnitsYDirection"		Type="1"
		SName="PhysicalDeltaX"			Type="1"
		SName="PhysicalDeltaY"			Type="1"
		SName="ReferencePixelX0"		Type="3"
		SName="ReferencePixelY0"		Type="3"
		SName="ReferencePixelPhysicalValueX"	Type="3"
		SName="ReferencePixelPhysicalValueY"	Type="3"
		SName="RegionSpatialFormat"		Type="1"	BinaryEnumValues="RegionSpatialFormat"
		SName="RegionDataType"			Type="1"	BinaryEnumValues="RegionDataType"
		SName="RegionFlags"			Type="1"	BinaryBitMap="RegionFlags"
		SName="PixelComponentOrganization"	Type="1C"	BinaryEnumValues="PixelComponentOrganization"
		SName="PixelComponentMask"		Type="1C"
		SName="PixelComponentRangeStart"	Type="1C"
		SName="PixelComponentRangeStop"		Type="1C"
		SName="PixelComponentPhysicalUnits"	Type="1C"	BinaryEnumValues="PixelComponentOrganization"
		SName="PixelComponentDataType"		Type="1C"	BinaryEnumValues="PixelComponentDataType"
		SName="NumberOfTableBreakPoints"	Type="1C"
		SName="TableOfXBreakPoints"		Type="1C"
		SName="TableOfYBreakPoints"		Type="1C"
		SName="TransducerFrequency"		Type="3"
		SName="Pulse RepetitionFrequency"	Type="3"
		SName="Doppler CorrectionAngle"		Type="3"
		SName="SteeringAngle"			Type="3"
		SName="DopplerSampleVolumeXPosition"	Type="3"
		SName="DopplerSampleVolumeYPosition"	Type="3"
		SName="TMLinePositionX0"		Type="3"
		SName="TMLinePositionY0"		Type="3"
		SName="TMLinePositionX1"		Type="3"
		SName="TMLinePositionY1"		Type="3"
	SequenceEnd

ModuleEnd

Module="USImage"

	Name="PhotometricInterpretation"		Type="1"	StringDefinedTerms="USPhotometricInterpretation"
	Name="PixelRepresentation"			Type="1"	BinaryEnumValues="PixelRepresentationUnsigned"
	Name="FrameIncrementPointer"			Type="1C"	Condition="Never"	# ... needs work
	Name="ImageType"				Type="2"  	StringDefinedTerms(3)="USImageType3" BinaryEnumValues(4)="USImageType4"
	Name="NumberOfStages"				Type="2C"	Condition="Never"	# "if acquired in a stage protocol" ... needs work
	Name="NumberOfViewsInStage"			Type="2C"	Condition="Never"	# "if acquired in a stage protocol" ... needs work
	Sequence="ReferencedOverlaySequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Sequence="ReferencedCurveSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="StageName"
	Name="StageNumber"				Type="3"
	Name="ViewNumber"				Type="3"
	Name="NumberOfEventTimers"			Type="3"
	Name="EventElapsedTime"				Type="3"
	Name="EventTimerName"				Type="3"
	Name="TransducerPosition"			Type="3"	StringDefinedTerms="USTransducerPosition"
	Name="TransducerOrientation"			Type="3"	StringDefinedTerms="USTransducerOrientation"
	Name="AnatomicStructure"			Type="3"	StringDefinedTerms="USAnatomicStructure"
	Name="TriggerTime"				Type="3"
	Name="NominalInterval"				Type="3"
	Name="BeatRejectionFlag"			Type="3"	StringEnumValues="YesNoLetter"
	Name="LowRRValue"				Type="3"
	Name="HighRRValue"				Type="3"
	Name="HeartRate"				Type="3"
	Name="OutputPower"				Type="3"
	Name="TransducerData"				Type="3"
	Name="TransducerType"				Type="3"	StringDefinedTerms="USTransducerType"
	Name="FocusDepth"				Type="3"
	Name="PreprocessingFunction"			Type="3"
	Name="MechanicalIndex"				Type="3"
	Name="ThermalIndex"				Type="3"
	Name="CranialThermalIndex"			Type="3"
	Name="SoftTissueThermalIndex"			Type="3"
	Name="SoftTissueFocusThermalIndex"		Type="3"
	Name="SoftTissueSurfaceThermalIndex"		Type="3"
	Name="DepthOfScanField"				Type="3"
	Name="ImageTransformationMatrix"		Type="3"
	Name="ImageTranslationVector"			Type="3"

ModuleEnd

Module="SCImageEquipment"

	Name="ConversionType"					Type="1"	StringDefinedTerms="ConversionType"
	Name="Modality"						Type="3"	StringEnumValues="Modality"
	Name="SecondaryCaptureDeviceID"				Type="3"
	Name="SecondaryCaptureDeviceManufacturer"		Type="3"
	Name="SecondaryCaptureDeviceManufacturerModelName"	Type="3"
	Name="SecondaryCaptureDeviceSoftwareVersion"		Type="3"
	Name="VideoImageFormatAcquired"				Type="3"
	Name="DigitalImageFormatAcquired"			Type="3"

ModuleEnd

Module="SCImage"

	Name="DateOfSecondaryCapture"			Type="3"
	Name="TimeOfSecondaryCapture"			Type="3"

ModuleEnd

Module="OverlayIdentification"

	Name="OverlayNumber"				Type="2"
	Name="OverlayDate"				Type="3"
	Name="OverlayTime"				Type="3"
	Sequence="ReferencedImageSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd

ModuleEnd

Module="OverlayPlane"

	Name="OverlayRows"				Type="1"
	Name="OverlayColumns"				Type="1"
	Name="OverlayType"				Type="1"	StringEnumValues="OverlayType"
	Name="OverlayOrigin"				Type="1"
	Name="OverlayBitsAllocated"			Type="1"
	Name="OverlayBitPosition"			Type="1"
	Name="OverlayData"				Type="1C"	Condition="Never"	# data may be in image pixels
	Name="ROIArea"					Type="3"
	Name="ROIMean"					Type="3"
	Name="ROIStandardDeviation"			Type="3"
	Name="OverlayDescriptorGray"			Type="3"
	Name="OverlayDescriptorRed"			Type="3"
	Name="OverlayDescriptorGreen"			Type="3"
	Name="OverlayDescriptorBlue"			Type="3"
	Name="OverlayGray"				Type="3"
	Name="OverlayRed"				Type="3"
	Name="OverlayGreen"				Type="3"
	Name="OverlayBlue"				Type="3"

ModuleEnd

Module="MultiFrameOverlay"

	Name="OverlayNumberOfFrames"			Type="1"

ModuleEnd

Module="CurveIdentification"

	Name="CurveNumber"				Type="2"
	Name="CurveDate"				Type="3"
	Name="CurveTime"				Type="3"
	Sequence="ReferencedImageSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Sequence="ReferencedOverlaySequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Sequence="ReferencedCurveSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd

ModuleEnd

Module="Curve"

	Name="CurveDimensions"				Type="1"
	Name="NumberOfPoints"				Type="1"
	Name="TypeOfData"				Type="1"	StringDefinedTerms="CurveTypeOfData"
	Name="DataValueRepresentation"			Type="1"	BinaryEnumValues="CurveDataValueRepresentation"
	Name="CurveData"				Type="1"
	Name="CurveDescription"				Type="3"
	Name="AxisUnits"				Type="3"	StringDefinedTerms="CurveAxisUnits"
	Name="AxisLabels"				Type="3"
	Name="MinimumCoordinateValue"			Type="3"
	Name="MaximumCoordinateValue"			Type="3"
	Name="CurveRange"				Type="3"
	Name="CurveDataDescriptor"			Type="1C"	BinaryEnumValues="CurveDataDescriptor"	Condition="Never"
	Name="CoordinateStartValue"			Type="1C"	Condition="CurveDataDescriptorPresent"
	Name="CoordinateStepValue"			Type="1C"	Condition="CurveDataDescriptorPresent"

ModuleEnd

Module="Audio"

	Name="AudioType"				Type="1"	BinaryEnumValues="AudioType"
	Name="AudioSampleFormat"			Type="1"	BinaryEnumValues="AudioSampleFormat"
	Name="NumberOfChannels"				Type="1"	BinaryEnumValues="NumberOfChannels"
	Name="NumberOfSamples"				Type="1"
	Name="SampleRate"				Type="1"
	Name="TotalTime"				Type="1"
	Name="AudioSampleData"				Type="1"
	Sequence="ReferencedImageSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd
	Name="AudioComments"

ModuleEnd

Module="ModalityLUT"

	Sequence="ModalityLUTSequence"			Type="3"
		SName="LUTDescriptor"			Type="1C"
		SName="LUTExplanation"			Type="3"
		SName="ModalityLUTType"			Type="1C"	StringDefinedTerms="ModalityLUTType"
		SName="LUTData"				Type="1C"
	SequenceEnd
	Name="RescaleIntercept"				Type="1C"	Condition="ModalityLUTSequenceNotPresent"
	Name="RescaleSlope"				Type="1C"	Condition="RescaleInterceptPresent"
	Name="RescaleType"				Type="1C"	Condition="RescaleInterceptPresent"

ModuleEnd

Module="VOILUT"

	Sequence="VOILUTSequence"			Type="3"
		SName="LUTDescriptor"			Type="1C"
		SName="LUTExplanation"			Type="3"
		SName="LUTData"				Type="1C"
	SequenceEnd
	Name="WindowCenter"				Type="3"
	Name="WindowWidth"				Type="1C"	Condition="WindowCenterPresent"
	Name="WindowCenterWidthExplanation"		Type="3"

ModuleEnd

Module="LUTIdentification"

	Name="LUTNumber"				Type="2"
	Sequence="ReferencedImageSequence"		Type="3"
		SName="ReferencedSOPClassUID"		Type="1C"
		SName="ReferencedSOPInstanceUID"	Type="1C"
	SequenceEnd

ModuleEnd

Module="SOPCommon"

	Name="SOPClassUID"				Type="1C"	Condition="Always"
	Name="SOPInstanceUID"				Type="1C"	Condition="Always"
	Name="SpecificCharacterSet"			Type="1C"	StringDefinedTerms="SpecificCharacterSet"	Condition="Never"
	Name="InstanceCreationDate"			Type="3"
	Name="InstanceCreationTime"			Type="3"
	Name="InstanceCreatorUID"			Type="3"

ModuleEnd

Module="BasicFilmSessionPresentation"

	Name="NumberOfCopies"
	Name="PrintPriority"				StringEnumValues="Priority"
	Name="MediumType"				StringDefinedTerms="MediumType"
	Name="FilmDestination"				StringEnumValues="FilmDestination"
	Name="FilmSessionLabel"
	Name="MemoryAllocation"

ModuleEnd

Module="BasicFilmSessionRelationship"

	Sequence="ReferencedFilmBoxSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="BasicFilmBoxPresentation"

	Name="ImageDisplayFormat"			StringDefinedTerms="ImageDisplayFormat"
	Name="AnnotationDisplayFormatID"
	Name="FilmOrientation"				StringEnumValues="Orientation"
	Name="FilmSizeID"				StringDefinedTerms="FilmSizeID"
	Name="MagnificationType"			StringDefinedTerms="MagnificationType"
	Name="SmoothingType"
	Name="BorderDensity"				StringDefinedTerms="Density"
	Name="EmptyImageDensity"			StringDefinedTerms="Density"
	Name="MinDensity"
	Name="MaxDensity"
	Name="Trim"					StringEnumValues="YesNoFull"
	Name="ConfigurationInformation"

ModuleEnd

Module="BasicFilmBoxRelationship"

	Sequence="ReferencedFilmSessionSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedImageBoxSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd
	Sequence="ReferencedBasicAnnotation BoxSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="ImageBoxPixelPresentation"

	Name="ImagePosition"
	Name="Polarity"					StringEnumValues="Polarity"
	Name="MagnificationType"			StringDefinedTerms="MagnificationType"
	Name="SmoothingType"
	Name="RequestedImageSize"
	Sequence="PreformattedGrayscaleImageSequence"
		SName="SamplesPerPixel"			BinaryEnumValues="SamplesPerPixelIsOne"
		SName="PhotometricInterpretation"	StringEnumValues="PhotometricInterpretationMonochrome"
		SName="Rows"
		SName="Columns"
		SName="PixelAspectRatio"
		SName="BitsAllocated"			BinaryEnumValues="BitsAre8Or16"
		SName="BitsStored"			BinaryEnumValues="BitsAre8Or16"
		SName="HighBit"				BinaryEnumValues="BitsAre7Or15"
		SName="PixelRepresentation"		BinaryEnumValues="PixelRepresentationUnsigned"
		SName="PixelData"
	SequenceEnd
	Sequence="Preformatted ColorImageSequence"
		SName="SamplesPerPixel"			BinaryEnumValues="SamplesPerPixelIsThree"
		SName="PhotometricInterpretation"	StringEnumValues="PhotometricInterpretationRGB"
		SName="PlanarConfiguration"		BinaryEnumValues="PlanarConfigurationIsFrameInterleave"
		SName="Rows"
		SName="Columns"
		SName="PixelAspectRatio"
		SName="BitsAllocated"			BinaryEnumValues="BitsAre8"
		SName="BitsStored"			BinaryEnumValues="BitsAre8"
		SName="HighBit"				BinaryEnumValues="BitsAre7"
		SName="PixelRepresentation"		BinaryEnumValues="PixelRepresentationUnsigned"
		SName="PixelData"
	SequenceEnd

ModuleEnd

Module="ImageBoxRelationship"

	Sequence="ReferencedImageSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
		SName="ReferencedFrameNumber"
	SequenceEnd
	Sequence="ReferencedImageOverlayBoxSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
		SName="ReferencedFrameNumber"
	SequenceEnd
	Sequence="ReferencedVOI LUTSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd

Module="BasicAnnotationPresentation"

	Name="AnnotationPosition"
	Name="TextString"

ModuleEnd

Module="PrintJob"

	Name="ExecutionStatus"				StringEnumValues="PrintExecutionStatus"
	Name="ExecutionStatusInfo"			StringDefinedTerms="PrintExecutionStatusInfo"
	Name="CreationDate"
	Name="CreationTime"
	Name="PrintPriority"
	Name="PrinterName"
	Name="Originator"

ModuleEnd

Module="Printer"

	Name="PrinterStatus"				StringEnumValues="PrinterStatus"
	Name="PrinterStatusInfo"			StringDefinedTerms="PrinterStatusInfo"
	Name="PrinterName"
	Name="Manufacturer"
	Name="ManufacturerModelName"
	Name="DeviceSerialNumber"
	Name="SoftwareVersion"
	Name="DateOfLastCalibration"
	Name="TimeOfLastCalibration"

ModuleEnd

Module="ImageOverlayBoxPresentation"

	Sequence="ReferencedOverlayPlaneSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
		SName="ReferencedOverlayPlaneGroups"
	SequenceEnd
	Name="OverlayMagnificationType"			StringDefinedTerms="MagnificationType"
	Name="OverlaySmoothingType"
	Name="OverlayForegroundDensity"			StringDefinedTerms="Density"
	Name="OverlayMode"				StringDefinedTerms="OverlayMode"
	Name="ThresholdDensity"				StringDefinedTerms="Density"

ModuleEnd

Module="ImageOverlayBoxRelationship"

	Sequence="ReferencedImageBoxSequence"
		SName="ReferencedSOPClassUID"
		SName="ReferencedSOPInstanceUID"
	SequenceEnd

ModuleEnd
