#!/bin/sh

versiona="$1"
versionb="$2"

adir="dicom3tools_$versiona"
bdir="dicom3tools_$versionb"

archivea="dicom3tools_$versiona.tar.gz"
archiveb="dicom3tools_$versionb.tar.gz"

diffname="dicom3tools_patch$versiona-$versionb.gz"

rm -fr $adir
rm -fr $bdir

mkdir $adir
mkdir $bdir

(cd $adir; gunzip < ../$archivea | tar -xvf -)
(cd $bdir; gunzip < ../$archiveb | tar -xvf -)

rm -f $diffname

# when new files exist, create empty old ones to force inclusion in diff ...
# "Only in dicom3tools_0.05: CHANGELOG" -> "touch dicom3tools_0.04/CHANGELOG"

`diff -r -c $adir $bdir | grep "^Only in $bdir" | sed "s/^Only in $bdir/touch $adir/" | sed 's|: |/|'`

# now do real diff ...

diff -r -c $adir $bdir | grep -v '^Common subdirectories: ' | gzip -best >$diffname

rm -fr $adir
rm -fr $bdir


