#  strval.awk 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.

# create a C++ header or method file to verify dicom binary values
# according to a description in the input template file

# can set these values on the command line:
#
#	role	  - either "header" or "method" (defaults to "header")

NR==1	{
	print "// Automatically generated from template - EDITS WILL BE LOST"
	print ""
	print "// Generated by strval.awk with options " role
	print ""

	if (role == "") role = "header"

	if (role == "header") {
		print "#ifndef _DC3tstrval_HEADER_"
		print "#define _DC3tstrval_HEADER_"
		print ""
	}
	else if (role == "method") {
		print "#include \"tstrvalt.h\""
		print "#include \"tstrval.h\""
		print ""
	}
	else {
		print "Error - role " role " invalid" >"/dev/tty"
		exit 1
	}

	mode=""
	}

/^[ 	]*StringValues/ {
	name=""
	if (match($0,"StringValues=\"[^\"]*\""))
		name=substr($0,RSTART+length("StringValues=\""),
			RLENGTH-length("StringValues=\"")-1);
	mode="values"

	if (role == "header") {
		print "char *\tDC3StringValueDescription_" name "(char * value);"
	}
	else if (role == "method") {
		print "static struct DC3StringValueEntry"
		print "DC3StringValueTable_" name "[] = {"
	}

	}

$0 !~ /(.*[{}])|(^[ 	]*$)/ {

	if (mode == "values") {
		valueline=$0
		if (match(valueline,"[0-9a-zA-Z ][0-9a-zA-Z ]*")) {
			code=substr(valueline,RSTART,RLENGTH)
			if (match(code,"[ 	]*$")) {
				code=substr(code,0,RSTART-1)
			}
			valueline=substr(valueline,RSTART+RLENGTH)
		}
		else {
			print "Line " FNR \
				": error in value line - no code <" \
				valueline ">" >"/dev/tty"
		}
		if (match(valueline,"[ 	]*=[ 	]*")) {
			meaning=substr(valueline,RSTART+RLENGTH)
			if (match(meaning,"[ 	]*,*[ 	]*$")) {
				meaning=substr(meaning,0,RSTART-1)
			}
		}
		else {
			meaning=""
		}

		if (role == "method") {
			print "\t\"" code "\",\t\"" meaning "\","
		}
	}
	else {
		print "Line " FNR ": error - no group name" >"/dev/tty"
	}

	}

/^[ 	]*}/ {
	if (role == "method" && mode == "values") {
		print "\t0,0"
		print "};"
		print ""
		print "char *"
		print "DC3StringValueDescription_" name "(char * value)"
		print "{"
		print "\treturn DC3StringValueDescription(DC3StringValueTable_" name ",value);"
		print "}"
		print ""
	}

	mode=""
	}

END {
	if (role == "header") {
		print ""
		print "#endif /* _DC3tstrval_HEADER_ */"
	}
}

