#  testlng.awk 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.

# read output of dc3dump and validate GroupLength & LengthToEnd values

# fixed part of an attribute (not included in VL)
#
#	- implicit VR:		8 bytes	 = 4 tag + 4 VL
#	- explicit VR:
#		- normal:	8 bytes  = 4 tag + 2 VR + 2 VL
#		- OB,OW,SQ:	12 bytes = 4 tag + 2 VR + 2 rsrv + 4 VL

function hextodec(hex) {
		gsub("x","0",hex);
		gsub("X","0",hex);
		n=length(hex);
		dec=0;
		i=1;
		while (i <= n) {
			digit=substr(hex,i,1);
			if (digit == "a") digit=10;
			else if (digit == "b") digit=11;
			else if (digit == "c") digit=12;
			else if (digit == "d") digit=13;
			else if (digit == "e") digit=14;
			else if (digit == "f") digit=15;
			else if (index("0123456789",digit) == 0) break;
			dec=dec*16+digit;
			++i;
		}
		return dec;
}

function endgroup(group,wanted,len,n,lastfixed,explicitfixup) {
		if (wanted) {
			if ((fixed=(wanted-len))/n == 8) {
				print "Group " group " VR explicit or implicit";
			}
			else if ((fixed=(wanted-len-explicitfixup)/n) == 8) {
				print "Group " group " VR explicit only";
			}
			else {
				print "Group " group " BAD: wanted " wanted \
					" got " len " (excluding fixed) with " \
					n " elements";
			}
		}
		else {
			print "Group " group " has no length attribute";
			fixed=0;
		}
		return fixed;
}

function endfile(wanted,len,n,lastfixed,explicitfixup) {
		if (wanted) {
			if ((fixed=(wanted-len))/n == 8) {
				print "LengthToEnd: VR explicit or implicit";
			}
			else if ((fixed=(wanted-len-explicitfixup)/n) == 8) {
				print "LengthToEnd: VR explicit only";
			}
			else {
				print "LengthToEnd: BAD: wanted " wanted \
					" got " len " (excluding fixed) with " \
					n " elements";
			}
		}
		else {
			print "File has no LengthToEnd attribute";
			fixed=0;
		}
		return fixed;
}

BEGIN	{
		doinggroup=0;
		grouplength=0;
		grouplengthwanted=0;
		nelements=0;
		lengthtoend=0;
		lengthtoendwanted=0;
		lengthtoendelements=0;
		lastfixed=0;
	}

/^[(][0-9a-zA-Z]+,[0-9a-zA-Z]+[)] [A-Z][A-Z]/ {

		match($0,"^[(][0-9a-zA-Z]+,");
		hexgroup=substr($0,RSTART+1,RLENGTH-2);
		group=hextodec(hexgroup);

		match($0,",[0-9a-zA-Z]+[)]");
		hexelement=substr($0,RSTART+1,RLENGTH-2);
		element=hextodec(hexelement);

		match($0,"\[[0-9a-zA-Z]*\]$");
		hexvalue=substr($0,RSTART+1,RLENGTH-2);
		decvalue=hextodec(hexvalue);

		match($0,"VL=<[0-9a-zA-Z]*>");
		hexlength=substr($0,RSTART+4,RLENGTH-5);
		declength=hextodec(hexlength);

		match($0,"VR=<[A-Z][A-Z]>");
		vr=substr($0,RSTART+4,RLENGTH-5);

		if (group != doinggroup) {
			if (doinggroup != 0) {
				lastfixed=endgroup(doinggroup,grouplengthwanted,
					grouplength,nelements,lastfixed,
					grouplengthfixup)
			}
			doinggroup=group;
			grouplength=0;
			grouplengthwanted=0;
			grouplengthfixup=0;
			nelements=0;
		}

		if (vr == "OB" || vr == "OW" || vr == "OX" || vr == "SQ") {
			explicitfixup=4;
		}
		else {
			explicitfixup=0;
		}

		if (element == 0) {
			grouplengthwanted=decvalue;
			print "new group " hexgroup " value " grouplengthwanted;
		}
		else {
			grouplength+=declength;
			grouplengthfixup+=explicitfixup;
			++nelements;
		}

		if (lengthtoendwanted != 0) {
			lengthtoend+=declength;
			lengthtoendfixup+=explicitfixup;
			++lengthtoendelements;
		}

		if (group == 8 && element == 1) {
			lengthtoendwanted=decvalue;
			lengthtoend=0;
			lengthtoendfixup=0;
			lengthtoendelements=0;
		}

		print "group " hexgroup " element " hexelement " hexvalue :" hexvalue ": decvalue :" decvalue ":" " hexlength :" hexlength ": declength :" declength ":";
		#print "group " hexgroup " element " hexelement " vr :" vr ":";
	}

END	{
		lastfixed=endgroup(doinggroup,grouplengthwanted,
			grouplength,nelements,lastfixed,
			grouplengthfixup)
		lastfixed=endfile(lengthtoendwanted,
			lengthtoend,lengthtoendelements,lastfixed,
			lengthtoendfixup)
	}

